;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Add a new category to the database
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure EditCategory()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Category\CurrentLine = GetGadgetState(#Gadget_MyInfo_Category)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If Category\CurrentLine <> #NoCurrentLine
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    ; "Current category line: " + Str(Category\CurrentLine)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Category\CurrentRecord = GetGadgetItemText(#Gadget_MyInfo_Category, Category\CurrentLine, #CategoryRecordColumn)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If Category\CurrentRecord <> #Empty$
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      ; "Current category record: " + Category\CurrentRecord
      
      ;--------------------------------------------------------------------------------------------
      ; Check if an existing window is opened
      ;--------------------------------------------------------------------------------------------
      
      If Program\WindowMutex <> #True
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        ; "No other window opened"
        
        ;------------------------------------------------------------------------------------------
        ; Try to open the data form window
        ;------------------------------------------------------------------------------------------
        
        If Window_Category()  <> #NoWindowId
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          ; "Managed to open the category editor window"
          
          ;----------------------------------------------------------------------------------------
          ; Window was opened so set mutex to prevent other windows from opening
          ;----------------------------------------------------------------------------------------
          
          Program\WindowMutex = #True
          
          ;----------------------------------------------------------------------------------------
          ; Add the fast form close keyboard shortcut
          ;----------------------------------------------------------------------------------------
          
          AddKeyboardShortcut(#Window_Category, #ShortcutValue_SaveCategory,     #KeyboardShortcut_SaveCategory)
          
          AddKeyboardShortcut(#Window_Category, #ShortcutValue_HelpCategory,     #KeyboardShortcut_HelpCategory)
          
          AddKeyboardShortcut(#Window_Category, #ShortcutValue_ExitCategory,     #KeyboardShortcut_ExitCategory)
          
          AddKeyboardShortcut(#Window_Category, #ShortcutValue_EscapeCategory,   #KeyboardShortcut_EscapeCategory)
          
          ;----------------------------------------------------------------------------------------
          ; Add the hover gadgets to this window
          ;----------------------------------------------------------------------------------------
          
          AddHoverGadget(GadgetID(#Gadget_Category_SaveCategory))
          
          AddHoverGadget(GadgetID(#Gadget_Category_HelpCategory))
          
          AddHoverGadget(GadgetID(#Gadget_Category_ExitCategory))
          
          ;----------------------------------------------------------------------------------------
          ; These are your balloon tooltips used on the main form. All headings, balloon text and 
          ; icons are re-useable variables taken from the constants file.
          ;----------------------------------------------------------------------------------------
          
          If Program\BalloonFontId
            
            BalloonToolTip(#Window_Category, #Gadget_Category_SaveCategory, Program\BalloonFontId, GetBalloonColour(), ShortTooltip\SaveCategory,  #CRLF$ + GetShortCutText(#ShortcutValue_SaveCategory) + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\SaveCategory, 30), GetIconHandle(#Image_Category_SaveCategory))
            
            BalloonToolTip(#Window_Category, #Gadget_Category_HelpCategory, Program\BalloonFontId, GetBalloonColour(), ShortTooltip\HelpCategory,  #CRLF$ + GetShortCutText(#ShortcutValue_HelpCategory) + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\HelpCategory, 30), GetIconHandle(#Image_Category_HelpCategory))
            
            BalloonToolTip(#Window_Category, #Gadget_Category_ExitCategory, Program\BalloonFontId, GetBalloonColour(), ShortTooltip\ExitCategory,  #CRLF$ + GetShortCutText(#ShortcutValue_ExitCategory) + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\ExitCategory, 30), GetIconHandle(#Image_Category_ExitCategory))
            
          Else
            
            MessageRequesterEBS("Balloon font load error", "Could not load the ballon font so no tooltips will be loaded", #MB_ICONINFORMATION | #PB_MessageRequester_Ok)
            
            ;MessageRequester("Balloon font load error", "Could not load the ballon font so no tooltips will be loaded", #PB_MessageRequester_Ok)
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; Disable all input on the main window until this one is closed
          ;----------------------------------------------------------------------------------------
          
          DisableWindow(#Window_MyInfo, #True)
          
          ;----------------------------------------------------------------------------------------
          ; Hide the main window until we are finished with the data window
          ;----------------------------------------------------------------------------------------
          
          ;HideWindow(#Window_MyInfo, #True)
          
          ;----------------------------------------------------------------------------------------
          ; Load the user chosen icons to be selected for locations
          ;----------------------------------------------------------------------------------------
          
          DirectoryId.i = ExamineDirectory(#PB_Any, Program\CategoryIcons, "*.ico")
          
          If DirectoryId.i
            
            Repeat
              
              TypeOfFile.i  = NextDirectoryEntry(DirectoryId.i) 
              
              IconName.s    = DirectoryEntryName(DirectoryId.i)
              
              If TypeOfFile.i = #True And IconName.s <> "." And IconName.s <> ".."
                
                If FileSize(Program\CategoryIcons  + IconName.s) <> #FileDoesNotExist And FileSize(Program\CategoryIcons  + IconName.s) <> #FileIsDirectory
                  
                  IconHandle.i = LoadImage(#PB_Any, Program\CategoryIcons  + IconName.s)
                  
                  If IconHandle.i <>  #NoPictureLoaded
                    
                    AddGadgetItem(#Gadget_Category_Categoryicon, #AtTheEndOfTheList, IconName.s, ImageID(IconHandle.i))
                    
                  Else
                    
                    AddGadgetItem(#Gadget_Category_Categoryicon, #AtTheEndOfTheList, IconName.s, ImageID(#Image_ListCategory))
                    
                    SetInfoBarArea("Headings", "Error", "Could load the icon file as it is damaged.", #PB_Compiler_Procedure)
                    
                  EndIf
                  
                Else
                  
                  AddGadgetItem(#Gadget_Category_Categoryicon, #AtTheEndOfTheList, IconName.s, ImageID(#Image_ListCategory))
                  
                  SetInfoBarArea("Headings", "Error", "Icon file does not exist or is damaged.", #PB_Compiler_Procedure)
                  
                EndIf
                
              EndIf 
              
            Until TypeOfFile.i = #False
            
          EndIf
      
          ;----------------------------------------------------------------------------------------
          ; Set the last window message for the closure routine later
          ;----------------------------------------------------------------------------------------
          
          Program\LastWindow = "Edit An Old Category"
          
          ;----------------------------------------------------------------------------------------
          ; Show new record number and status in the data window
          ;----------------------------------------------------------------------------------------
          
          SetWindowTitle(#Window_Category, Program\LastWindow + ":  Old record")
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          DatabaseQuery.s               + 

          "SELECT Category, Iconname "  + 
          
          "FROM Categories "            + 
          
          "WHERE Recordid = '"          + 

          Category\CurrentRecord        + 

          "'"
          
          If DatabaseQuery(Program\DatabaseHandle, DatabaseQuery.s) <> #DatabaseQueryFail
            
            While NextDatabaseRow(Program\DatabaseHandle) <>  #NoDatabaseRow
              
              Category\OldCategoryString  = GetDatabaseString(Program\DatabaseHandle, 0)
              
              Iconname.s                  = GetDatabaseString(Program\DatabaseHandle, 1)
              
            Wend
            
            FinishDatabaseQuery(Program\DatabaseHandle)
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          ;           Category\OldCategoryString = Trim(StringField(GetGadgetItemText(#Gadget_MyInfo_Category, Category\CurrentLine, #CategoryTitleColumn), 1, "("))
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          SetGadgetText(#Gadget_Category_Category,      Category\OldCategoryString)
          
          SetGadgetText(#Gadget_Category_Categoryicon,  IconName.s)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          SetGadgetText(#Gadget_Category_RecordNumber, "Record No: " + GetGadgetItemText(#Gadget_MyInfo_Category, Category\CurrentLine, #CategoryRecordColumn))
          
          ;----------------------------------------------------------------------------------------
          ; Show new record number and status in the main window
          ;----------------------------------------------------------------------------------------
          
          SetInfoBarArea("Headings", "Info", Program\LastWindow, #PB_Compiler_Procedure)
          
          ;----------------------------------------------------------------------------------------
          ; Make sure the data form window is topmost
          ;----------------------------------------------------------------------------------------
          
          SetActiveWindow(#Window_Category)
          
          ;----------------------------------------------------------------------------------------
          ; Make sure the version field is selected
          ;----------------------------------------------------------------------------------------
          
          SetActiveGadget(#Gadget_Category_Category)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          HideWindow(#Window_Category, #False)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings", "Error", "The ["  + Program\LastWindow + "] window could not be opened.", #PB_Compiler_Procedure)
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings", "Warn",  "The ["  + Program\LastWindow + "] program window is still open, close that one first.", #PB_Compiler_Procedure)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings", "Warn", "There was no record number found on the selected line.", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Warn", "There is no category selected for editing.", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 107
; FirstLine = 103
; Folding = -
; EnableXP
; HideErrorLog
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableExeConstant