;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Show the  category selected in the category tree
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure ShowCategory()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  CurrentLine.i = GetGadgetState(#Gadget_MyInfo_Category)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If CurrentLine <> #NoCurrentLine
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    CurrentCategory.s = RepQuote(Trim(StringField(GetGadgetItemText(#Gadget_MyInfo_Category, CurrentLine.i, 0), 1, "(")))
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If CurrentCategory.s <> #Empty$
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      Queue\CurrentCategory.s = CurrentCategory.s
      
      Queue\CategoryItems.s   = GetGadgetItemText(#Gadget_MyInfo_Category, CurrentLine.i, #CategoryItemsColumn)
      
      SetGadgetItemText(#Gadget_MyInfo_Category, #ListIconHeadingArea, Queue\CurrentCategory.s + ", [" + Queue\CategoryItems.s  + "]", 0)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetGadgetText(#Gadget_MyInfo_Information, #Empty$)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      Select Queue\CurrentCategory.s

        ;------------------------------------------------------------------------------------------
          
        Case "All items"      ; Where the title isn't empty
          
          QueryString.s   = "SELECT * FROM MyInfo WHERE Title <> '' "
          
         ;QueryString.s   + "AND Owner <> '' "
          
         ;QueryString.s   + "AND Category <> '' "
          
         QueryString.s   + "AND Archived <> '1' "
          
         QueryString.s   + "AND Favourite <> '1' "
          
         QueryString.s   + "AND Deleted <> '1' "
          
         QueryString.s   + "AND Locked <> '1' "
          
         ;QueryString.s   + "AND Title LIKE '%" + RepQuote(Program\LastSearch)  + "%' " 

          ;----------------------------------------------------------------------------------------
          
        Case "Empty titles"   ; Where the title is empty
          
          QueryString.s   = "SELECT * FROM MyInfo WHERE Title = '' "
          
          ;----------------------------------------------------------------------------------------
          
        Case "Archived"     ; Where the title is archived
          
          QueryString.s   = "SELECT * FROM MyInfo WHERE Archived = '1' "
          
          ;----------------------------------------------------------------------------------------
          
        Case "Favourites"     ; Where the title is a favourite
          
          QueryString.s   = "SELECT * FROM MyInfo WHERE Favourite = '1' "
          
          ;----------------------------------------------------------------------------------------
          
        Case "Locked items"   ; Where the title is locked
          
          QueryString.s   = "SELECT * FROM MyInfo WHERE Locked = '1' "
          
          ;----------------------------------------------------------------------------------------
          
        Case "Deleted items"  ; Where the item is marked deleted
          
          QueryString.s   = "SELECT * FROM MyInfo WHERE Deleted = '1' "
          
          ;----------------------------------------------------------------------------------------
          
        Case "No category"    ; Where an item has no category
          
          QueryString.s   = "SELECT * FROM MyInfo WHERE Category = '' "
          
          ;----------------------------------------------------------------------------------------
          
        Case "No owner"       ; Where an item has no owner
          
          QueryString.s   = "SELECT * FROM MyInfo WHERE Owner = '' "
          
          ;----------------------------------------------------------------------------------------
          
        Default
          
          QueryString.s   = "SELECT * FROM MyInfo WHERE Category = '" + Queue\CurrentCategory.s + "' "
          
         ;QueryString.s   + "AND Title LIKE '%" + RepQuote(Program\LastSearch)  + "%' " 
          
         ;QueryString.s   + "AND Owner <> '' "
          
         ;QueryString.s   + "AND Category <> '' "
          
         ;QueryString.s   + "AND Archived <> '1 "
          
         ;QueryString.s   + "AND Favourite <> '1' "
          
         ;QueryString.s   + "AND Deleted <> '1' "
          
         ;QueryString.s   + "AND Locked <> '1' "
          
          ;----------------------------------------------------------------------------------------
          
      EndSelect
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      QueryString.s + "ORDER BY Title ASC "
      
      If Program\SearchLimit <> "0"
        
        QueryString.s + "LIMIT "  + Program\SearchLimit
      
      EndIf
    
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      LineCounter.i         = #NoItems
      
      DeletedLineCounter.i  = #NoItems
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      LockWindowUpdate_(GadgetID(#Gadget_MyInfo_Titles))
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      ; QueryString.s
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If DatabaseQuery(Program\DatabaseHandle,  QueryString.s) <> #DatabaseQueryFail
        
        ClearGadgetItems(#Gadget_MyInfo_Titles)
        
        While NextDatabaseRow(Program\DatabaseHandle)
          
          MyInfo\Title        = KillQuote(GetDatabaseString(Program\DatabaseHandle,  0))                 ;
          
          MyInfo\Information  = KillQuote(GetDatabaseString(Program\DatabaseHandle,  1))                 ;
          
          MyInfo\Category     = KillQuote(GetDatabaseString(Program\DatabaseHandle,  2))                 ;
          
          MyInfo\Archived     =           GetDatabaseString(Program\DatabaseHandle,  3)                  ;
          
          MyInfo\Favourite    =           GetDatabaseString(Program\DatabaseHandle,  4)                  ;
          
          MyInfo\Locked       =           GetDatabaseString(Program\DatabaseHandle,  5)                  ;
          
          MyInfo\Deleted      =           GetDatabaseString(Program\DatabaseHandle,  6)                  ;
          
          MyInfo\Updated      =   IsoDate(GetDatabaseString(Program\DatabaseHandle,  7), "NormalDate")   ;
          
          MyInfo\Owner        = KillQuote(GetDatabaseString(Program\DatabaseHandle,  8))                 ;
          
          MyInfo\Attachments  =           GetDatabaseString(Program\DatabaseHandle,  9)                  ;
          
          MyInfo\Recordid     =           GetDatabaseString(Program\DatabaseHandle, 10)                  ;
          
          If MyInfo\Deleted  = "1"
            
            DeletedLineCounter.i + 1
            
          EndIf
          
          DisplayTitleString(LineCounter.i, "AddMode")
          
          LineCounter.i + 1
          
        Wend
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        FinishDatabaseQuery(Program\DatabaseHandle)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        LockWindowUpdate_(0)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        Queue\ItemsFound.i     = LineCounter.i
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        SetInfoBarArea("Records", #Empty$, Str(LineCounter.i), #PB_Compiler_Procedure)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        SetGadgetState(#Gadget_MyInfo_Titles, #FirstItem); #PB_ListIcon_Selected)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        ShowMyInfoData()
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings",  "Error",  "The database query has failed or was empty: " + DatabaseError(), #PB_Compiler_Procedure)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings",  "Info",  "No category string was found on that line.", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Info",  "There is no current line selected.", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 198
; FirstLine = 194
; Folding = -
; EnableXP
; HideErrorLog
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableExeConstant