;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Update category item count in category list
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure SyncCategories()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  NewList CategoryName.s()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  DatabaseQuery.s = "SELECT Category FROM Categories"
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If DatabaseQuery(Program\DatabaseHandle, DatabaseQuery.s) <> #DatabaseQueryFail
    
    While NextDatabaseRow(Program\DatabaseHandle) <> #NoItems
      
      AddElement(CategoryName.s())
      
      CategoryName.s()  = KillQuote(GetDatabaseString(Program\DatabaseHandle,  0))
      
    Wend
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    FinishDatabaseQuery(Program\DatabaseHandle)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    ForEach CategoryName.s()
      
      CategoryQuery.s             + 

      "SELECT COUNT(Category) "   + 

      "AS totalrecs FROM MyInfo " + 

      "WHERE Category = '"        + 

      RepQuote(CategoryName.s())  + 

      "'"
      
      If DatabaseQuery(Program\DatabaseHandle, CategoryQuery.s) <> #DatabaseQueryFail
        
        While NextDatabaseRow(Program\DatabaseHandle) <> #NoItems
          
          ItemInCategoryCount.s = GetDatabaseString(Program\DatabaseHandle,  0) ; ItemInCategoryCount.s + " ::: "  + CategoryName.s()
          
        Wend
        
        FinishDatabaseQuery(Program\DatabaseHandle)
        
        If ItemInCategoryCount.s <> "0"
          
          CategoryUpdate.s            + 

          "UPDATE Categories "        + 
          
          "SET Itemcount = '"         + 

          ItemInCategoryCount.s       + 

          "' "                        + 
          
          "WHERE Category = '"        + 

          RepQuote(CategoryName.s())  + 

          "'"
          
          If DatabaseUpdate(Program\DatabaseHandle, CategoryUpdate.s) <> #DatabaseUpdateFail
            
            SetInfoBarArea("Headings", "Info", "Updated the category item count for:  ", #PB_Compiler_Procedure)
            
          Else
            
            SetInfoBarArea("Headings", "Error", "Failed to update category item count: " + KillQuote(CategoryName.s()), #PB_Compiler_Procedure)
            
          EndIf
          
        Else
          
          SetInfoBarArea("Headings", "Info", "There are no items found for this category", #PB_Compiler_Procedure)
          
        EndIf
        
      Else
        
        SetInfoBarArea("Headings", "Error", "The database query failed or was empty: " + DatabaseError(), #PB_Compiler_Procedure)
        
      EndIf
      
    Next  CategoryName.s()
    
    ;----------------------------------------------------------------------------------------------
    ; Reload the resynced categories list
    ;----------------------------------------------------------------------------------------------
    
    ClearGadgetItems(#Gadget_MyInfo_Category)
    
    LoadCategories()
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Error", "The database query failed or was empty: " + DatabaseError(), #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 70
; FirstLine = 53
; Folding = -
; EnableAsm
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableExeConstant
; EnableUnicode