﻿;==========================================================================================================================================================
; Decode a serial stream of data
;==========================================================================================================================================================

Procedure.s DecodeSerialStream(SerialString.s)
  
  ;------------------------------------------------------------------------------------------------
  ; Check if we have some data to decode and it is big enough to work with
  ;------------------------------------------------------------------------------------------------
  
  If Len(SerialString.s) And Len(SerialString.s) > 1
    
    ;----------------------------------------------------------------------------------------------
    ; Allocate memory to the compression area
    ;----------------------------------------------------------------------------------------------
    
    *EncodeBuffer = AllocateMemory(Len(SerialString.s))
    
    ;----------------------------------------------------------------------------------------------
    ; Only proceed if the buffer was able to be allocated
    ;----------------------------------------------------------------------------------------------
    
    If *EncodeBuffer
      
      ;--------------------------------------------------------------------------------------------
      ; Decode the string of data and check to se if we got anything
      ;--------------------------------------------------------------------------------------------
      
      ActualBytesEncoded.i = Base64Decoder(@SerialString.s, Len(SerialString.s), *EncodeBuffer, MemorySize(*EncodeBuffer))
      
      ;--------------------------------------------------------------------------------------------
      ; If we got any decoding on the string, we can now return it to the calling procedure
      ;--------------------------------------------------------------------------------------------
      
      If ActualBytesEncoded.i
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        ProcedureReturn PeekS(*EncodeBuffer, ActualBytesEncoded.i)

        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        ; "Serial stream is " + Str(ActualBytesEncoded.i) + " bytes, nothing to do."
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If *EncodeBuffer
        
        FreeMemory(*EncodeBuffer)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      ; "Could not allocate a memory buffer as the file it was for is empty."
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    ; "This line of data happens to be empty so we cannot allocate memory for it."
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 78
; FirstLine = 45
; Folding = -
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0