﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Convert an ISO format date to Australian and back
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure.s IsoDate(DateString.s, Direction.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

  Select Direction.s

    ;----------------------------------------------------------------------------------------------
    ; From Iso Date to normal (yyyy-mm-dd to dd/mm/yyyy)
    ;----------------------------------------------------------------------------------------------
  
    Case "NormalDate"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If DateString.s <> #Empty$
        
        ;------------------------------------------------------------------------------------------
        ; American standard ISO date format
        ;------------------------------------------------------------------------------------------
        
        If Mid(DateString.s, 5, 1)  = "-" And Mid(DateString.s, 8, 1)  = "-"
          
          ;----------------------------------------------------------------------------------------
          ; From 2014-06-22 to 22/06/2014
          ;----------------------------------------------------------------------------------------
          
          FixedDate.s = StringField(DateString.s, 3, "-") + "/"     ; Day
          
          FixedDate.s + StringField(DateString.s, 2, "-") + "/"     ; Month
          
          FixedDate.s + StringField(DateString.s, 1, "-")           ; Year 
    
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings",  "Error",  "This is not an ISO format date for conversion", #PB_Compiler_Procedure)
          
          FixedDate.s = "#ERROR#"
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------

      Else
        
        FixedDate.s = #Empty$
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; To Iso date from normal (dd/mm/yyyy to yyyy-mm-dd)
      ;--------------------------------------------------------------------------------------------

    Case "IsoDate"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If DateString.s <> #Empty$
        
        ;------------------------------------------------------------------------------------------
        ; From 22/06/2014 to 2014-06-22
        ;------------------------------------------------------------------------------------------
        
        If Mid(DateString.s, 3, 1)  = "/" And Mid(DateString.s, 6, 1)  = "/"
            
          ;----------------------------------------------------------------------------------------
          ; Conversion for SQLite for proper sorting
          ;----------------------------------------------------------------------------------------
          
          FixedDate.s = StringField(DateString.s, 3, "/") + "-"     ; Year
          
          FixedDate.s + StringField(DateString.s, 2, "/") + "-"     ; Month
          
          FixedDate.s + StringField(DateString.s, 1, "/")           ; Day
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
        
        Else
          
          SetInfoBarArea("Headings",  "Error",  "This not a normal date format for conversion", #PB_Compiler_Procedure)
          
          FixedDate.s = "#ERROR#"
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
      
      Else
        
        FixedDate.s = #Empty$
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

  ProcedureReturn FixedDate.s
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

EndProcedure

; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 131
; FirstLine = 88
; Folding = -
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0