;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Send messages and error reports to the fake status bar area
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure SetInfoBarArea(FieldName.s, FieldStatus.s, MessageContent.s = "0", ModuleName.s = #Empty$)
  
  ;------------------------------------------------------------------------------------------------
  ; Select the name of the field to put our heading string
  ;------------------------------------------------------------------------------------------------
  
  Select FieldName.s

    ;----------------------------------------------------------------------------------------------
    ; Select the correct heading by the status field
    ;----------------------------------------------------------------------------------------------
    
    Case "Headings"
    
      ;--------------------------------------------------------------------------------------------
      ; This is the field status heading and message
      ;--------------------------------------------------------------------------------------------
      
      Select FieldStatus.s
          
        Case "Welcome"
          
          MessageHeader.s = "Welcome"
          
          Colour.i        = $DB3D24
          
        Case "Button"
          
          MessageHeader.s = "Button tool tip"
          
          Colour.i        = $00008B
          
        Case "Info"
          
          MessageHeader.s = "Information"
          
          Colour.i        = $DB3D24
          
        Case "Warn"
          
          MessageHeader.s = "Warning"
          
          Colour.i        = $7D1F82
          
          WriteErrorLog(ModuleName.s, MessageContent.s)
          
        Case "Error"
          
          MessageHeader.s = "Error"
          
          Colour.i        = $0402FB
          
          WriteErrorLog(ModuleName.s, MessageContent.s)
          
      EndSelect
      
      ;--------------------------------------------------------------------------------------------
      ; Send all the strings to the fake status bar area
      ;--------------------------------------------------------------------------------------------
      
      SetGadgetText(#Gadget_MyInfo_Heading,      MessageHeader.s + ">>")

      SetGadgetText(#Gadget_MyInfo_Messages,     MessageContent.s)
      
      SetGadgetColor(#Gadget_MyInfo_Messages,    #PB_Gadget_FrontColor, Colour.i)
      
      ;--------------------------------------------------------------------------------------------
      ; This is the current record number field
      ;--------------------------------------------------------------------------------------------

    Case "Number"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetGadgetText(#Gadget_MyInfo_Current, "Number " + MessageContent.s)
      
      ;--------------------------------------------------------------------------------------------
      ; This is the number of displayed records field
      ;--------------------------------------------------------------------------------------------
      
    Case "Records"
      
      ;--------------------------------------------------------------------------------------------
      ; Figure out the correct spelling for the record field for singles or multiples
      ;--------------------------------------------------------------------------------------------
      
      If Val(MessageContent.s)         = 0
        
        RecordHeader.s = "Items"
        
      ElseIf Val(MessageContent.s)    = 1
        
        RecordHeader.s = "Item"
        
      ElseIf Val(MessageContent.s) >  = 2
        
        RecordHeader.s = "Items"
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; Set the record number details in the fake status bar area
      ;--------------------------------------------------------------------------------------------
      
      SetGadgetText(#Gadget_MyInfo_Records, MessageContent.s + " " + RecordHeader.s)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 82
; FirstLine = 75
; Folding = -
; EnableXP
; DisableDebugger
; HideErrorLog
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableExeConstant