﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure SaveScannedDocumentPages()
  
  ;------------------------------------------------------------------------------------------------
  ; Finalise and save pdf file
  ;------------------------------------------------------------------------------------------------
  
  PdfDocumentAndPath.s = SaveFileRequester("Save PDF file", Program\DocumentDirectory.s,  "PDF (*.pdf)|*.pdf",  0)

  ;------------------------------------------------------------------------------------------------
  ; Check that the extension is correct
  ;------------------------------------------------------------------------------------------------
  
  If LCase(GetExtensionPart(PdfDocumentAndPath.s))  <> "pdf"

    PdfDocumentAndPath.s  + ".pdf"

  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

  If PdfDocumentAndPath.s <> #Empty$

    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SetGadgetText(#Gadget_Scan_lTargetdocument,         GetFilePart(PdfDocumentAndPath.s))
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If PdfDocumentAndPath.s
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      pdf_Save(PdfDocumentAndPath.s)  ; Save this for the user as a separate file
      
      ; Now generate a file fingerprint which will be the name in the database
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      FileToSaveFingerPrint.s = FileFingerprint(PdfDocumentAndPath.s, #PB_Cipher_MD5) 
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If FileToSaveFingerPrint.s
        
        ;----------------------------------------------------------------------------------------
        ; 
        ;----------------------------------------------------------------------------------------
        
        CurrentPdfDocumentHandle.i = ReadFile(#PB_Any, PdfDocumentAndPath.s)
        
        ;----------------------------------------------------------------------------------------
        ; 
        ;----------------------------------------------------------------------------------------
        
        If CurrentPdfDocumentHandle.i
          
          ;--------------------------------------------------------------------------------------
          ; 
          ;--------------------------------------------------------------------------------------
          
          PdfDocumentFileLength.i  = Lof(CurrentPdfDocumentHandle.i)
          
          ;--------------------------------------------------------------------------------------
          ; 
          ;--------------------------------------------------------------------------------------
          
          If PdfDocumentFileLength.i
            
            ;------------------------------------------------------------------------------------
            ; 
            ;------------------------------------------------------------------------------------
            
            *InputBuffer            = AllocateMemory(PdfDocumentFileLength.i)
            
            *BlobBuffer             = AllocateMemory(PdfDocumentFileLength.i)
            
            ;------------------------------------------------------------------------------------
            ; 
            ;------------------------------------------------------------------------------------
            
            If *InputBuffer And *BlobBuffer
              
              ;----------------------------------------------------------------------------------
              ; 
              ;----------------------------------------------------------------------------------
              
              If ReadData(CurrentPdfDocumentHandle.i, *InputBuffer, PdfDocumentFileLength.i) = PdfDocumentFileLength.i
                
                ;--------------------------------------------------------------------------------
                ; 
                ;--------------------------------------------------------------------------------
                
                CompressedLength.i = CompressMemory(*InputBuffer, PdfDocumentFileLength.i, *BlobBuffer, PdfDocumentFileLength.i)
                
                ;--------------------------------------------------------------------------------
                ; 
                ;--------------------------------------------------------------------------------
                
                If CompressedLength.i
                  
                  SetDatabaseBlob(Program\DatabaseHandle, 0, *BlobBuffer,   CompressedLength.i)
                  
                Else
                  
                  SetDatabaseBlob(Program\DatabaseHandle, 0, *InputBuffer,  PdfDocumentFileLength.i)
                  
                EndIf
                
                ;--------------------------------------------------------------------------------
                ; 
                ;--------------------------------------------------------------------------------
                
                DatabaseUpdate.s                            +        ; 

                "INSERT INTO PdfDocuments ("                +        ; 

                "Attachmentid, "                            +        ; 

                "Attachment, "                              +        ; 

                "Filename "                                 +        ; 

                ") "                                        +        ; 

                "VALUES ('"                                 +        ; 

                Program\CurrentRecord.s                     +        ; This is the id of the record to which this PdfDocument links
                
                "', "                                       +        ; 

                "?, '"                                      +        ; This is the PdfDocument blob

                RepQuote(GetFilePart(PdfDocumentAndPath.s)) +        ; This is the PdfDocument filename

                "')"
                
                ;--------------------------------------------------------------------------------
                ; 
                ;--------------------------------------------------------------------------------
                
                If DatabaseUpdate(Program\DatabaseHandle, DatabaseUpdate.s) <> #DatabaseUpdateFail
                  
                  ;------------------------------------------------------------------------------
                  ; 
                  ;------------------------------------------------------------------------------
                  
                  NewRecord.s = DatabaseLastInsertRowId()
                  
                  ;------------------------------------------------------------------------------
                  ; 
                  ;------------------------------------------------------------------------------
                  
                  If NewRecord.s <> #Empty$
                    
                    PdfDocumentsSaved.i = #True
                    
                    SetInfoBarArea("Headings", "Info", PdfDocumentAndPath.s  + " saved for record: " + CurrentRecord.s, #PB_Compiler_Procedure)
                    
                  Else
                    
                    SetInfoBarArea("Headings", "Error", "Could not gtet a new record number for the PdfDocument inserted. "  + DatabaseError(), #PB_Compiler_Procedure)  
                    
                  EndIf
                  
                  ;------------------------------------------------------------------------------
                  ; 
                  ;------------------------------------------------------------------------------
                  
                Else
                  
                  SetInfoBarArea("Headings", "Error", "The database insertion of the specified PdfDocument has failed "  + DatabaseError(), #PB_Compiler_Procedure)  
                  
                EndIf
                
                ;--------------------------------------------------------------------------------
                ; 
                ;--------------------------------------------------------------------------------
                
              Else
                
                SetInfoBarArea("Headings", "Error", "Could not read the data from the specified PdfDocument file.", #PB_Compiler_Procedure)  
                
              EndIf
              
              ;----------------------------------------------------------------------------------
              ; 
              ;----------------------------------------------------------------------------------
              
              FreeMemory(*BlobBuffer)
              
              FreeMemory(*InputBuffer)
              
              ;----------------------------------------------------------------------------------
              ; 
              ;----------------------------------------------------------------------------------
              
            Else
              
              SetInfoBarArea("Headings", "Error", "Could not allocate memory areas to save the specified PdfDocument file.", #PB_Compiler_Procedure)  
              
            EndIf
            
            ;------------------------------------------------------------------------------------
            ; 
            ;------------------------------------------------------------------------------------
            
            CloseFile(CurrentPdfDocumentHandle.i)
            
            ;------------------------------------------------------------------------------------
            ; 
            ;------------------------------------------------------------------------------------
            
          Else
            
            SetInfoBarArea("Headings", "Warn", "Could not open the specified PdfDocument file.", #PB_Compiler_Procedure)  
            
          EndIf
          
          ;--------------------------------------------------------------------------------------
          ; 
          ;--------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings", "Error", "The PdfDocument was empty or damaged, cannot add it.", #PB_Compiler_Procedure)  
          
        EndIf
        
        ;----------------------------------------------------------------------------------------
        ; 
        ;----------------------------------------------------------------------------------------
        
        UpdateTitleAttachmentCount(Program\CurrentLine.i, Program\CurrentRecord.s)
        
        ;----------------------------------------------------------------------------------------
        ; 
        ;----------------------------------------------------------------------------------------
        
      Else
        
        MessageRequester("Scan2PDF",  "Could not create a document fingerprint, possibly due to file system error")
      
      EndIf
      
      ;------------------------------------------------------------------------------------------
      ; 
      ;------------------------------------------------------------------------------------------
      
    Else
      
      MessageRequester("Scan2PDF",  "The user chose file could not be saved or does not exist")
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If Not AquireDocument(GetGadgetState(#Gadget_Scan_Imagetype) + 1, lQuality, #True)
      
      MessageRequester("Scan2PDF",  "Could not reset PDF Engine, please restart application.")
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    ; Need a graphic button to replace the below gadget setting
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SetGadgetText(#Gadget_Scan_sStatus, "Scan the next page")
    
    ;----------------------------------------------------------------------------------------------
    ; Breeze4me code to turn a disabled image properly greyscale
    ;----------------------------------------------------------------------------------------------
    
    DisableImageGadget(#Gadget_Scan_FinishScan, #Image_Scan_FinishScan, #True)
    
   ;DisableGadget(#Gadget_Scan_FinishScan, #True)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Info",  "Nothing to save, user cancelled the process.", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------  
  ; 
  ;------------------------------------------------------------------------------------------------  

EndProcedure

; IDE Options = PureBasic 5.70 LTS (Windows - x86)
; CursorPosition = 295
; FirstLine = 272
; Folding = -
; EnableAsm
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableExeConstant
; EnableUnicode