﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Scan an attachment into the current record
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure ScanDocument()
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  Program\CurrentLine.i = GetGadgetState(#Gadget_MyInfo_Titles)
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  If  Program\CurrentLine.i <> #NoCurrentLine
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    Program\CurrentRecord.s = GetGadgetItemText(#Gadget_MyInfo_Titles, Program\CurrentLine.i, #RecordColumn)
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    If Program\CurrentRecord.s  <> #Empty$
      
      ;--------------------------------------------------------------------------------------------
      ;
      ;--------------------------------------------------------------------------------------------
      
      If Window_Scan()  <> #NoWindowId
        
        ;------------------------------------------------------------------------------------------
        ; Prevent user input on the main window
        ;------------------------------------------------------------------------------------------
        
        DisableWindow(#Window_MyInfo, #True)
        
        ;------------------------------------------------------------------------------------------
        ; Warn other components a window is open and not to attempt to open another
        ;------------------------------------------------------------------------------------------
        
        Program\WindowMutex = #True
        
        ;------------------------------------------------------------------------------------------
        ; Add keyboard shortcuts as backup to the buttons, Good for people with sore mouse wrists
        ;------------------------------------------------------------------------------------------
        
        AddKeyboardShortcut(#Window_Scan, #ShortcutValue_NextScan,         #KeyboardShortcut_NextScan)
        
        AddKeyboardShortcut(#Window_Scan, #ShortcutValue_FinishScan,       #KeyboardShortcut_FinishScan)
        
        AddKeyboardShortcut(#Window_Scan, #ShortcutValue_HelpScan,         #KeyboardShortcut_HelpScan)
        
        AddKeyboardShortcut(#Window_Scan, #ShortcutValue_CancelScan,       #KeyboardShortcut_CancelScan)
        
        ;------------------------------------------------------------------------------------------
        ; Add the hover enabled images
        ;------------------------------------------------------------------------------------------
        
        AddHoverGadget(GadgetID(#Gadget_Scan_NextScan))
        
        AddHoverGadget(GadgetID(#Gadget_Scan_FinishScan))
        
        AddHoverGadget(GadgetID(#Gadget_Scan_HelpScan))
        
        AddHoverGadget(GadgetID(#Gadget_Scan_CancelScan))
        
        ;------------------------------------------------------------------------------------------
        ; Balloon tooltips with keyboard shortcut display
        ;------------------------------------------------------------------------------------------
        
        If Program\BalloonFontId
          
          BalloonToolTip(#Window_Scan, #Gadget_Scan_NextScan,     Program\BalloonFontId, GetBalloonColour(), ShortTooltip\NextScan,    #CRLF$ + GetShortCutText(#ShortcutValue_NextScan)   + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\NextScan,    30),  GetIconHandle(#Image_Scan_NextScan))
          
          BalloonToolTip(#Window_Scan, #Gadget_Scan_FinishScan,   Program\BalloonFontId, GetBalloonColour(), ShortTooltip\FinishScan,  #CRLF$ + GetShortCutText(#ShortcutValue_FinishScan) + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\FinishScan,  30),  GetIconHandle(#Image_Scan_FinishScan))
          
          BalloonToolTip(#Window_Scan, #Gadget_Scan_HelpScan,     Program\BalloonFontId, GetBalloonColour(), ShortTooltip\HelpScan,    #CRLF$ + GetShortCutText(#ShortcutValue_HelpScan)   + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\HelpScan,    30),  GetIconHandle(#Image_Scan_HelpScan))
          
          BalloonToolTip(#Window_Scan, #Gadget_Scan_CancelScan,   Program\BalloonFontId, GetBalloonColour(), ShortTooltip\CancelScan,  #CRLF$ + GetShortCutText(#ShortcutValue_CancelScan) + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\CancelScan,  30),  GetIconHandle(#Image_Scan_CancelScan))
          
        Else
          
          MessageRequesterEBS("Balloon font load error", "Could not load the ballon font so no tooltips will be loaded", #MB_ICONINFORMATION | #PB_MessageRequester_Ok)
          
          ;MessageRequester("Balloon font load error", "Could not load the ballon font so no tooltips will be loaded", #PB_MessageRequester_Ok)
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; Remove theme support from the comment box or it retains a border even when API removed
        ;------------------------------------------------------------------------------------------
        
        RemoveBorders(#Gadget_Scan_lTargetDocument)
        
        ;------------------------------------------------------------------------------------------
        ;
        ;------------------------------------------------------------------------------------------
        
        SetWindowTitle(#Window_Scan, "Scan a new document for record: " + Program\CurrentRecord.s)
        
        ;------------------------------------------------------------------------------------------
        ;
        ;------------------------------------------------------------------------------------------
        
        AddGadgetItem(#Gadget_Scan_Imagetype,     #AtTheEndOfTheList, "Black & White")
        
        AddGadgetItem(#Gadget_Scan_Imagetype,     #AtTheEndOfTheList, "GrayScale")
        
        AddGadgetItem(#Gadget_Scan_Imagetype,     #AtTheEndOfTheList, "Colour (Photo)") ; Default on most scanners
        
        ;------------------------------------------------------------------------------------------
        ;
        ;------------------------------------------------------------------------------------------
        
        SetGadgetState(#Gadget_Scan_Imagetype,  2)
        
        ;------------------------------------------------------------------------------------------
        ;
        ;------------------------------------------------------------------------------------------
        
        AddGadgetItem(#Gadget_Scan_Imagequality,  #AtTheEndOfTheList, "  75 dpi")
        
        AddGadgetItem(#Gadget_Scan_Imagequality,  #AtTheEndOfTheList, " 100 dpi")
        
        AddGadgetItem(#Gadget_Scan_Imagequality,  #AtTheEndOfTheList, " 150 dpi")
        
        AddGadgetItem(#Gadget_Scan_Imagequality,  #AtTheEndOfTheList, " 300 dpi")   ; Default on most scanners
        
        AddGadgetItem(#Gadget_Scan_Imagequality,  #AtTheEndOfTheList, " 600 dpi")
        
        AddGadgetItem(#Gadget_Scan_Imagequality,  #AtTheEndOfTheList, "1200 dpi")
        
        ;------------------------------------------------------------------------------------------
        ;
        ;------------------------------------------------------------------------------------------
        
        SetGadgetState(#Gadget_Scan_Imagequality, 3)
        
        ;------------------------------------------------------------------------------------------
        ;
        ;------------------------------------------------------------------------------------------
        
        ; Need a graphic button to replace the below gadget setting
        
        ;------------------------------------------------------------------------------------------
        ;
        ;------------------------------------------------------------------------------------------
        
        SetGadgetText(#Gadget_Scan_lTargetdocument, #Empty$)
        
        ;------------------------------------------------------------------------------------------
        ; Breeze4me code to turn a disabled image properly greyscale
        ;------------------------------------------------------------------------------------------
        
        SetGadgetData(#Gadget_Scan_FinishScan, -1) ; essential line !
        
        DisableImageGadget(#Gadget_Scan_FinishScan, #Image_Scan_FinishScan, #True)
        
        ;------------------------------------------------------------------------------------------
        ;
        ;------------------------------------------------------------------------------------------
        
        SetGadgetText(#Gadget_Scan_sStatus, "Scan your first page, nothing done as yet.")
        
        ;------------------------------------------------------------------------------------------
        ;
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings",  "Error",  "Could not open the Scan window", #PB_Compiler_Procedure)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ;
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings",  "Error",  "There was no record number found on that line", #PB_Compiler_Procedure)  
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Info",  "There is no current line selected", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.70 LTS (Windows - x86)
; CursorPosition = 159
; FirstLine = 141
; Folding = -
; EnableAsm
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableExeConstant
; EnableUnicode