﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Import a preformatted text file from disk
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure ImportItemFromDisk()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ImportFileName.s = OpenFileRequester("Import item", Program\TemporaryDirectory, "Text (*.txt)|*.txt;*.asc", 0)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If ImportFileName.s <> #Empty$
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    ; Debug "We got a filename  : " + ImportFileName.s
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    ImportFileId.i = ReadFile(#PB_Any, ImportFileName.s)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If ImportFileId.i <> #NoFileHandle
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      ; Debug "We got a file handle:  " + Str(ImportFileId.i)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      While Eof(ImportFileId.i) = #NotEndOfFile
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        CurrentString.s + ReadString(ImportFileId.i, #PB_File_IgnoreEOL)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        ; Debug "We read the current string : " + CurrentString.s
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
      Wend
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      CloseFile(ImportFileId.i)      
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      Title.s         = StringField(CurrentString.s, 1, "|")
      
      Information.s   = StringField(CurrentString.s, 2, "|")
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If Title.s <> #Empty$ And Information.s <> #Empty$
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        ; Debug "The title was extracted:  " + Title.s
        
        ; Debug "_-/----------\-_"
        
        ; Debug "The information was extracted: " + Information.s
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        AddNewData()
        
        SetGadgetText(#Gadget_Data_Title,   Title.s)
        
        SetGadgetText(#Gadget_Data_Details, Information.s)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        ; Debug "The title and information strings may not be empty"
        
        SetInfoBarArea("Headings", "Error", "The title and information strings may not be empty", #PB_Compiler_Procedure)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      ; Debug "No import file handle was created"
      
      SetInfoBarArea("Headings", "Error", "No import file handle was created", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    ; Debug "Nothing to open, user cancelled"
    
    SetInfoBarArea("Headings", "Warn", "Nothing to open, user cancelled", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 137
; FirstLine = 94
; Folding = -
; EnableAsm
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0