﻿;============================================================================================================================================================
; Open the text search window
;============================================================================================================================================================

Procedure OpenFindTextWindow()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If CountGadgetItems(#Gadget_Data_Details) <> 0
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If Window_Search()
      
      ;--------------------------------------------------------------------------------------------
      ; Remove theme support for certain gadgets where colours don't seem to work in PureBasic. This is
      ; as there is no crossplatform colour support for these controls
      ;--------------------------------------------------------------------------------------------
      
      SetWindowTheme_(GadgetID(#Gadget_FindText_matchcase),   @null.w, @null.w)
      
      SetWindowTheme_(GadgetID(#Gadget_FindText_fup),         @null.w, @null.w)
      
      SetWindowTheme_(GadgetID(#Gadget_FindText_fdown),       @null.w, @null.w)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetWindowCallback(@SearchWindowCallback(), #Window_FindText)

      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      StickyWindow(#Window_FindText, #True)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      AddKeyboardShortcut(#Window_FindText, #PB_Shortcut_Return,  #Shortcut_FindText_FindFirst)
      
      AddKeyboardShortcut(#Window_FindText, #PB_Shortcut_F3,      #Shortcut_FindText_FindNext)
      
      AddKeyboardShortcut(#Window_FindText, #PB_Shortcut_Escape,  #Shortcut_FindText_escape)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetGadgetState(#Gadget_FindText_Fdown, 1)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetActiveGadget(#Gadget_FindText_Find)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      ; SetStatusBar(2, "Could not open the text searching window")
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    ; SetStatusBar(2, "Nothing to search in, add some text first")
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.24 LTS (Windows - x86)
; CursorPosition = 4
; Folding = -
; EnableXP