;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Save the new or edited MyInfo data
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure SaveThisData()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  MyInfo\Title        = RepQuote(GetGadgetText(#Gadget_Data_Title))
  
  MyInfo\Information  = RepQuote(GetGadgetText(#Gadget_Data_Details))
  
  MyInfo\Category     = RepQuote(GetGadgetText(#Gadget_Data_cCategory))
  
; MyInfo\Archived     = RepQuote(GetGadgetText(#Gadget_Data_Archived))
  
; MyInfo\Favourite    = RepQuote(GetGadgetText(#Gadget_Data_Favourite))

; MyInfo\Locked       = RepQuote(GetGadgetText(#Gadget_Data_Locked))

; MyInfo\Deleted      = RepQuote(GetGadgetText(#Gadget_Data_Deleted))

  MyInfo\Updated      = FormatDate("%yyyy-%mm-%dd", Date())              ; ISO standard date format
  
  MyInfo\Owner        = RepQuote(GetGadgetText(#Gadget_Data_Owner))
  
; MyInfo\Attachments  = "0"
  
; MyInfo\Recordid     = RepQuote(GetGadgetText(#Gadget_Data_Recordnumber))
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If MyInfo\Title <> #Empty$ And MyInfo\Information <> #Empty$
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Select Program\LastWindow
     
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      Case  "Add New MyInfo Item"
      
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        MyInfo\Archived     = "0"
        
        MyInfo\Favourite    = "0"
        
        MyInfo\Locked       = "0"
        
        MyInfo\Deleted      = "0"
        
        MyInfo\Attachments  = "0"
        
        ;----------------------------------------------------------------------------------------
        ; 
        ;----------------------------------------------------------------------------------------
        
        MyInfoInsertString.s                + 

        "INSERT INTO MyInfo("               + 
        
        "Title, "                           + 

        "Information, "                     + 

        "Category, "                        + 

        "Archived, "                        + 

        "Favourite, "                       + 

        "Locked, "                          + 

        "Deleted, "                         + 

        "Updated, "                         + 
        
        "Owner, "                           + 

        "Attachments) "                     + 
        
        "VALUES("                           + 
        
        "'"   +   MyInfo\Title        + "'" + 
        
        ", '" +   MyInfo\Information  + "'" + 
        
        ", '" +   MyInfo\Category     + "'" + 
        
        ", '" +   MyInfo\Archived     + "'" + 
        
        ", '" +   MyInfo\Favourite    + "'" + 
        
        ", '" +   MyInfo\Locked       + "'" + 
        
        ", '" +   MyInfo\Deleted      + "'" + 
        
        ", '" +   MyInfo\Updated      + "'" + 
        
        ", '" +   MyInfo\Owner        + "'" + 
        
        ", '" +   MyInfo\Attachments  + "'" + 
        
        ")"
        
        ;----------------------------------------------------------------------------------------
        ; 
        ;----------------------------------------------------------------------------------------
        
        If DatabaseUpdate(Program\DatabaseHandle, MyInfoInsertString.s)  <> #DatabaseUpdateFail
          
          MyInfo\Recordid = DatabaseLastInsertRowId()
          
          If MyInfo\Recordid <> #Empty$
            
            If Toggle\MessageSave = #True
              
              MessageRequesterEBS("New Item", "New item: " + KillQuote(MyInfo\Title)  + " has been saved to the database", #MB_ICONINFORMATION | #PB_MessageRequester_Ok)
              
              ;MessageRequester("New Item", "New item: " + KillQuote(MyInfo\Title)  + " has been saved to the database", #PB_MessageRequester_Ok)
            
            EndIf
            
            NewNumberOfItems.i = CountGadgetItems(#Gadget_MyInfo_Titles)
            
            DisplayTitleString(NewNumberOfItems.i,  "AddMode")
            
            LastLine(#Gadget_MyInfo_Titles, NewNumberOfItems.i - 1)
            
          Else
            
            SetInfoBarArea("Headings",  "Error",  "No record number created " + DatabaseError(), #PB_Compiler_Procedure)
            
          EndIf
          
        Else
          
          SetInfoBarArea("Headings", "Error", "Database table failed to be updated " + DatabaseError(), #PB_Compiler_Procedure)
          
        EndIf
          
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Case "Edit Old MyInfo Item"
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        MyInfoUpdateString.s                                   + 

        "UPDATE MyInfo SET "                                   + 
        
        "Title = '"           + MyInfo\Title           + "', "  + 
        
        "Information = '"     + MyInfo\Information     + "', "  + 
        
        "Category = '"        + MyInfo\Category        + "', "  + 
        
       ;"Archived = '"        + MyInfo\Archived        + "', "  + 
        
       ;"Favourite = '"       + MyInfo\Favourite       + "', "  + 
       
       ;"Locked = '"          + MyInfo\Locked          + "', "  + 

       ;"Deleted = '"         + MyInfo\Deleted         + "'  "  + 
        
        "Updated = '"         + MyInfo\Updated         + "', "  + 
        
        "Owner = '"           + MyInfo\Owner           + "'  "  + 
        
       ;"Attachments = '"     + MyInfo\Attachments     + "'  "  + 
        
        "WHERE Recordid = '"  + Program\CurrentRecord  + "'"
        
        ;----------------------------------------------------------------------------------------
        ; 
        ;----------------------------------------------------------------------------------------
        
        If DatabaseUpdate(Program\DatabaseHandle, MyInfoUpdateString.s)
          
          If Toggle\MessageSave = #True
            
            MessageRequesterEBS("Old Item", "Old item: " + KillQuote(MyInfo\Title)  + " has been saved to the database", #MB_ICONINFORMATION | #PB_MessageRequester_Ok)
            
            ;MessageRequester("Old Item", "Old item: " + KillQuote(MyInfo\Title)  + " has been saved to the database", #PB_MessageRequester_Ok)
          
          EndIf
          
          DisplayTitleString(Program\CurrentLine, "EditMode")
          
          LogFile.i = OpenFile(#PB_Any, Program\CurrentDirectory + "EditRecordLog.txt")
          
          If LogFile.i 
            
            WriteStringN(LogFile.i, "Edit of record worked okay")
            
            WriteStringN(LogFile.i, "--------------------------")
            
            WriteStringN(LogFile.i, UpdateString.s)
            
            WriteStringN(LogFile.i, "--------------------------")
            
            CloseFile(LogFile.i)
            
          Else
            
            SetInfoBarArea("Headings", "Warn",  "Error writing to log file", #PB_Compiler_Procedure)
            
          EndIf
          
        Else
          
          If LogFile.i 
            
            WriteStringN(LogFile.i, "Edit of record didn't work")
            
            WriteStringN(LogFile.i, "--------------------------")
            
            WriteStringN(LogFile.i, UpdateString.s)
            
            WriteStringN(LogFile.i, DatabaseError())
            
            WriteStringN(LogFile.i, "--------------------------")
            
            CloseFile(LogFile.i)
            
          Else
            
            SetInfoBarArea("Headings", "Warn",  "Editing of this record failed", #PB_Compiler_Procedure)
            
          EndIf
          
          ; Debug "Headings::  Error::  Database table failed to be updated:: " + DatabaseError()  + "::  "  + MyInfoUpdateString.s
          
          SetInfoBarArea("Headings", "Error", "Database table failed to be updated " + DatabaseError(), #PB_Compiler_Procedure)
          
        EndIf

        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
    EndSelect
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Program\ReFocusLine = Program\CurrentLine
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    CloseMyWindow(#Window_Data)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    UpdateCategoryItemCount(MyInfo\Category)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    ;SortTitleStrings(MyInfo\Title)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
  
  Else
    
    SetInfoBarArea("Headings",  "Error",  "The title and information fields must not be empty", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 248
; FirstLine = 223
; Folding = -
; EnableXP
; HideErrorLog
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableExeConstant