;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Search for items in the database
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure SearchDatabase()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  SearchField.s = GetGadgetText(#Gadget_MyInfo_Searchfield)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  SearchText.s  = GetGadgetText(#Gadget_MyInfo_Searchstring)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Program\LastSearch  = SearchText.s
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  QueryString.s       = "UPDATE Preferences "
  
  QueryString.s       + "SET LastSearch = '" + RepQuote(Program\LastSearch)  + "' "
  
  QueryString.s       + "WHERE Record = '1'"
  
  DatabaseUpdate(Program\DatabaseHandle, QueryString.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ClearGadgetItems(#Gadget_MyInfo_Titles)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  SetGadgetText(#Gadget_MyInfo_Searchstring, #Empty$)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Select  SearchField.s
      
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Case "All fields"
    
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If SearchText.s <> #Empty$

        QueryString.s = "SELECT * FROM MyInfo "
        
        QueryString.s + "WHERE Title LIKE '%"     + SearchText.s  + "%' " 
        
        QueryString.s + "OR Information LIKE '%"  + SearchText.s  + "%' " 
        
        ;         QueryString.s + "OR Category LIKE '%"     + SearchText.s  + "%' " 
        ;         
        ;         QueryString.s + "OR Owner LIKE '%"        + SearchText.s  + "%' " 
        ;         
        ;         QueryString.s + "OR Updated LIKE '%"      + SearchText.s  + "%' " 
        ;         
        ;         QueryString.s + "OR Record LIKE '%"       + SearchText.s  + "%' "
        ;         
        ;         QueryString.s + "AND Favourite <> '1' "
        ;         
        ;         QueryString.s + "AND Deleted <> '1' "
        ;         
        ;         QueryString.s + "AND Locked <> '1' "
        
        QueryString.s + "ORDER BY Title ASC"
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Default
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If SearchText.s <> #Empty$
        
        QueryString.s = "SELECT * FROM MyInfo "
        
        QueryString.s + "WHERE '"   + SearchField.s + "' "
        
        QueryString.s + "LIKE '%"   + SearchText.s  + "%' "
        
        QueryString.s + "AND Title <> '' "
        
        ;         QueryString.s + "AND Favourite <> '1' "
        ;         
        ;         QueryString.s + "AND Deleted <> '1' "
        ;         
        ;         QueryString.s + "AND Locked <> '1' "
        
        QueryString.s + "ORDER BY Title ASC"
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------

  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  PseudoCounter.i = #NoItems
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  LockWindowUpdate_(GadgetID(#Gadget_MyInfo_Titles))

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If DatabaseQuery(Program\DatabaseHandle,  QueryString.s)  <> #DatabaseQueryFail
    
    While NextDatabaseRow(Program\DatabaseHandle)
      
      MyInfo\Title        = KillQuote(GetDatabaseString(Program\DatabaseHandle,  0))                 ;
      
      MyInfo\Information  = KillQuote(GetDatabaseString(Program\DatabaseHandle,  1))                 ;
      
      MyInfo\Category     = KillQuote(GetDatabaseString(Program\DatabaseHandle,  2))                 ;
      
      MyInfo\Archived     =           GetDatabaseString(Program\DatabaseHandle,  3)                  ;
      
      MyInfo\Favourite    =           GetDatabaseString(Program\DatabaseHandle,  4)                  ;
      
      MyInfo\Locked       =           GetDatabaseString(Program\DatabaseHandle,  5)                  ;
      
      MyInfo\Deleted      =           GetDatabaseString(Program\DatabaseHandle,  6)                  ;
      
      MyInfo\Updated      =   IsoDate(GetDatabaseString(Program\DatabaseHandle,  7), "NormalDate")   ;
      
      MyInfo\Owner        = KillQuote(GetDatabaseString(Program\DatabaseHandle,  8))                 ;
      
      MyInfo\Attachments  =           GetDatabaseString(Program\DatabaseHandle,  9)                  ;
      
      MyInfo\Recordid     =           GetDatabaseString(Program\DatabaseHandle, 10)                  ;
      
      DisplayTitleString(PseudoCounter.i, "AddMode")
      
      PseudoCounter.i + 1
      
    Wend
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    FinishDatabaseQuery(Program\DatabaseHandle)
    
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
    LockWindowUpdate_(0)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SetInfoBarArea("Records", #Empty$, Str(PseudoCounter.i), #PB_Compiler_Procedure)
    
    ;----------------------------------------------------------------------------------------------
    ; Scroll the last line into view after the searches are complete
    ;----------------------------------------------------------------------------------------------
    
    SetActiveGadget(#Gadget_MyInfo_Titles)
    
    PostEvent(#PB_Event_Gadget, #Window_MyInfo, #Gadget_MyInfo_Titles, #PB_EventType_Change)
    
    SetGadgetItemState(#Gadget_MyInfo_Titles, PseudoCounter.i -1, #PB_ListIcon_Selected)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SetActiveGadget(#Gadget_MyInfo_Searchstring)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SetInfoBarArea("Records", #Empty$, Str(CountGadgetItems(#Gadget_MyInfo_Titles)), #PB_Compiler_Procedure)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Error",  "The database query has failed or was empty " + DatabaseError(), #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 164
; FirstLine = 142
; Folding = -
; EnableXP
; HideErrorLog
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableExeConstant