﻿;==========================================================================================================================================================
; Show the category selected in the category tree
;==========================================================================================================================================================

Procedure ShowCategory()
  
  ;--------------------------------------------------------------------------------------------
  ; 
  ;--------------------------------------------------------------------------------------------
  
  CurrentLine.i = GetGadgetState(#Gadget_PasswordMuncher_Category)
  
  ;--------------------------------------------------------------------------------------------
  ; 
  ;--------------------------------------------------------------------------------------------
  
  If CurrentLine <> -1
    
    ;------------------------------------------------------------------------------------------
    ; 
    ;------------------------------------------------------------------------------------------
    
    CurrentCategory.s = GetGadgetItemText(#Gadget_PasswordMuncher_Category, CurrentLine.i, 0)
    
    ;------------------------------------------------------------------------------------------
    ; 
    ;------------------------------------------------------------------------------------------
      
    If CurrentCategory.s <> ""
      
      ;----------------------------------------------------------------------------------------
      ; 
      ;----------------------------------------------------------------------------------------
      
      ClearGadgetItems(#Gadget_PasswordMuncher_Titles)
      
      ;----------------------------------------------------------------------------------------
      ; 
      ;----------------------------------------------------------------------------------------
      
      Select CurrentCategory.s
          
        Case "_-=All=-_"        : QueryString.s = "SELECT * FROM Passwords ORDER BY Title ASC"
          
        Case "_-=Deleted=-_"    : QueryString.s = "SELECT * FROM Passwords WHERE Deleted = '1' ORDER BY Title ASC"
          
        Case "_-=Empty=-_"      : QueryString.s = "SELECT * FROM Passwords WHERE Title = '' AND Deleted = '0' ORDER BY Title ASC"
          
        Case "_-=Favourite=-"   : QueryString.s = "SELECT * FROM Passwords WHERE Favourite = '1' AND Deleted = '0' ORDER BY Title ASC"
          
        Case "_-=Protected=-_"  : QueryString.s = "SELECT * FROM Passwords WHERE Locked = '1' ORDER BY Title ASC"
          
        Default                 : QueryString.s = "SELECT * FROM Passwords "
        
                                   QueryString.s + "WHERE Category = '" + CurrentCategory.s + "' "
                                  
                                   QueryString.s + "AND Deleted = '0' "
                                  
                                   QueryString.s + "ORDER BY Title ASC"
                                   
      EndSelect
      
      ;----------------------------------------------------------------------------------------
      ; 
      ;----------------------------------------------------------------------------------------
      
      PseudoCounter.i = 0
      
      ;----------------------------------------------------------------------------------------
      ; 
      ;----------------------------------------------------------------------------------------
      
      If DatabaseQuery(Program\DatabaseHandle,  QueryString.s)
        
        While NextDatabaseRow(Program\DatabaseHandle)
          
          Password\Title        = KillQuote(GetDatabaseString(Program\DatabaseHandle, 0)) ;
          
          Password\Information  = KillQuote(GetDatabaseString(Program\DatabaseHandle, 1)) ;
          
          Password\Category     =           GetDatabaseString(Program\DatabaseHandle, 2)  ;
          
          Password\Favourite    =           GetDatabaseString(Program\DatabaseHandle, 3)  ;
          
          Password\Locked       =           GetDatabaseString(Program\DatabaseHandle, 4)  ;
          
          Password\Deleted      =           GetDatabaseString(Program\DatabaseHandle, 5)  ;
          
          Password\Record       =           GetDatabaseString(Program\DatabaseHandle, 6)  ;
          
          DisplayTitleString(PseudoCounter.i, "AddMode")
          
          PseudoCounter.i + 1
          
        Wend
        
        ;--------------------------------------------------------------------------------------
        ; 
        ;--------------------------------------------------------------------------------------
        
        FinishDatabaseQuery(Program\DatabaseHandle)
        
        ;--------------------------------------------------------------------------------------
        ; 
        ;--------------------------------------------------------------------------------------
        
        SetGadgetItemText(#Gadget_PasswordMuncher_Category, -1, "> " + CurrentCategory.s, 0)

        SetInfoBarArea("Records", "", Str(PseudoCounter.i))
        
        ;--------------------------------------------------------------------------------------
        ; Scroll the last line into view
        ;--------------------------------------------------------------------------------------
        
;        SetActiveGadget(#Gadget_PasswordMuncher_Titles)
        
        PostEvent(#PB_Event_Gadget, #Window_PasswordMuncher, #Gadget_PasswordMuncher_Titles, #PB_EventType_Change)
        
        SetGadgetItemState(#Gadget_PasswordMuncher_Titles, PseudoCounter.i -1, #PB_ListIcon_Selected)
        
        ;--------------------------------------------------------------------------------------
        ; 
        ;--------------------------------------------------------------------------------------
        
        SetInfoBarArea("Records", "", Str(CountGadgetItems(#Gadget_PasswordMuncher_Titles)))
        
        ;--------------------------------------------------------------------------------------
        ; 
        ;--------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings",  "Error",  "The database query has failed or was empty " + DatabaseError())
        
      EndIf
      
      ;----------------------------------------------------------------------------------------
      ; 
      ;----------------------------------------------------------------------------------------

    Else
      
      ; No category string found on that line
      
    EndIf
    
    ;------------------------------------------------------------------------------------------
    ; 
    ;------------------------------------------------------------------------------------------
      
  Else
    
    ; There is no current line selected
    
  EndIf
  
  ;--------------------------------------------------------------------------------------------
  ; 
  ;--------------------------------------------------------------------------------------------

EndProcedure

; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 107
; FirstLine = 72
; Folding = -
; EnableXP
; HideErrorLog
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0