;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Update the attachment counter in the title list
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure UpdateTitleAttachmentCount(CurrentLine.i, CurrentRecord.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
 ;Debug CurrentRecord.s
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

  QueryString.s                     +

  "Select COUNT(Attachmentid) "     + ; The Id of the record in MyInfo that this belongs to
  
  "AS totalrecs FROM Attachments "  + 
  
  "WHERE Attachmentid = '"          + ; Actual record number of the attachment

  CurrentRecord.s                   + 

  "'"
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If DatabaseQuery(Program\DatabaseHandle, QueryString.s) <> #DatabaseQueryFail
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If NextDatabaseRow(Program\DatabaseHandle)
      
      NumberOfRecords.s = GetDatabaseString(Program\DatabaseHandle, 0)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    FinishDatabaseQuery(Program\DatabaseHandle)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------

    UpdateString.s        +

    "UPDATE MyInfo "      + 
    
    "Set Attachments = '" + 

    NumberOfRecords.s     + 

    "' "                  + 
    
    "WHERE Recordid = '"  + 

    CurrentRecord.s       + 

    "'"
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If DatabaseUpdate(Program\DatabaseHandle, UpdateString.s) <> #DatabaseUpdateFail
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      CurrentTitleString.s = GetGadgetItemText(#Gadget_MyInfo_Titles, CurrentLine.i, #TitleColumn)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      BracketFound.i = FindString(CurrentTitleString.s, "(", 1)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If BracketFound.i <> #NothingFound
        
        CurrentTitleString.s = Trim(StringField(CurrentTitleString.s, 1, "("))
        
        SetGadgetItemText(#Gadget_MyInfo_Titles, CurrentLine.i, CurrentTitleString.s  + " (" +  NumberOfRecords.s + ")",  #TitleColumn)
        
        SetGadgetItemText(#Gadget_MyInfo_Titles, CurrentLine.i, NumberOfRecords.s,                                        #AttachmentsColumn)
        
      ElseIf BracketFound.i = #NothingFound 
        
        SetGadgetItemText(#Gadget_MyInfo_Titles, CurrentLine.i, CurrentTitleString.s  + " (" +  NumberOfRecords.s + ")",  #TitleColumn)
        
        SetGadgetItemText(#Gadget_MyInfo_Titles, CurrentLine.i, NumberOfRecords.s,                                        #AttachmentsColumn)
        
      EndIf    
    
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      Debug "Could not update the attachment column for the current record: " + DatabaseError()
      
      SetInfoBarArea("Headings", "Error", "Could not update the attachment column for the current record: " + DatabaseError(), #PB_Compiler_Procedure)
      
    EndIf

    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
  Else
    
    Debug "Could get the correct attachment count for the current record: " + DatabaseError()
    
    SetInfoBarArea("Headings", "Error", "Could get the correct attachment count for the current record: " + DatabaseError(), #PB_Compiler_Procedure)
    
  EndIf        

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 76
; FirstLine = 48
; Folding = -
; EnableAsm
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableExeConstant
; EnableUnicode