;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Open someone else's database for use
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure OpenADatabase()
  
  ;------------------------------------------------------------------------------------------------
  ; Protect local variables from global conflicts
  ;------------------------------------------------------------------------------------------------
  
  Protected.s DatabaseName.s
  
  Protected.i DatabaseHandle.i
  
  ;------------------------------------------------------------------------------------------------
  ; Ask the user to open another database
  ;------------------------------------------------------------------------------------------------
  
  DatabaseName.s = OpenFileRequester("Open Database", Program\DatabaseDirectory, "MyInfo database file (*.sqlite)|*.sqlite", 0)  ;: Debug FormatField("Database name", 25)  + DatabaseName.s
  
  ;------------------------------------------------------------------------------------------------
  ; Check if the user selected another database
  ;------------------------------------------------------------------------------------------------
  
  If DatabaseName.s <> #Empty$
    
    ;----------------------------------------------------------------------------------------------
    ; Open the selected database in sqlite mode
    ;----------------------------------------------------------------------------------------------
    
    DatabaseHandle.i = OpenDatabase(#PB_Any, DatabaseName.s, #Empty$, #Empty$, #PB_Database_SQLite)                                   ;: Debug FormatField("Database handle", 25)  + Str(DatabaseHandle.i)
    
    ;----------------------------------------------------------------------------------------------
    ; If we got an open handle, proceed to the next task
    ;----------------------------------------------------------------------------------------------
    
    If DatabaseHandle.i <>  #DatabaseNotOpen
      
      ;--------------------------------------------------------------------------------------------
      ; Close the currently open database
      ;--------------------------------------------------------------------------------------------
      
      CloseDatabase(Program\DatabaseHandle.i)
      
      ;--------------------------------------------------------------------------------------------
      ; Set the global database handle to the successfully opened one
      ;--------------------------------------------------------------------------------------------
      
      Program\DatabaseHandle.i = DatabaseHandle.i
      
      ;--------------------------------------------------------------------------------------------
      ; Clear the existing category list
      ;--------------------------------------------------------------------------------------------
      
      ClearGadgetItems(#Gadget_MyInfo_Category)
      
      ;--------------------------------------------------------------------------------------------
      ; Load the standard categories and the ones in the database
      ;--------------------------------------------------------------------------------------------
      
      LoadCategories()
      
      ;--------------------------------------------------------------------------------------------
      ; Post an event to trigger the category display
      ;--------------------------------------------------------------------------------------------
      
      PostEvent(#PB_Event_Gadget, #Window_MyInfo, #Gadget_MyInfo_Category, #PB_EventType_Change)
      
      ;--------------------------------------------------------------------------------------------
      ; Now display all the records using the search routine
      ;--------------------------------------------------------------------------------------------
      
      SearchDatabase()
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings",  "Error",  "Cannot open other database.", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Error",  "Cannot open other database.", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 101
; FirstLine = 58
; Folding = -
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableExeConstant