;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; MyInfo 'About' window
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure AboutMyInfo()
  
  ;------------------------------------------------------------------------------------------------
  ; See if there is another window open still
  ;------------------------------------------------------------------------------------------------
  
  If Program\WindowMutex = #False
    
    ;----------------------------------------------------------------------------------------------
    ; Attempt to open the module window
    ;----------------------------------------------------------------------------------------------
    
    If Window_About()
      
      ;--------------------------------------------------------------------------------------------
      ; Set the window check flag so no others will open
      ;--------------------------------------------------------------------------------------------
      
      Program\WindowMutex = #True
      
      ;--------------------------------------------------------------------------------------------
      ; Disable the main window
      ;--------------------------------------------------------------------------------------------
      
      DisableWindow(#Window_MyInfo, #True)
      
      ;--------------------------------------------------------------------------------------------
      ; Set the last window (and title message) string
      ;--------------------------------------------------------------------------------------------
      
      Program\LastWindow = "About " + #Program
      
      ;--------------------------------------------------------------------------------------------
      ; Set the window title here
      ;--------------------------------------------------------------------------------------------
      
      SetWindowTitle(#Window_About, Program\LastWindow)
      
      ;--------------------------------------------------------------------------------------------
      ; Remove borders from the details pane by remove windows theming support, gets rid of 1 pixel border
      ;--------------------------------------------------------------------------------------------
      
      RemoveBorders(#Gadget_About_Information)
      
      ;--------------------------------------------------------------------------------------------
      ; Add the various keyboard shortcuts
      ;--------------------------------------------------------------------------------------------
      
      AddKeyboardShortcut(#Window_About, #ShortcutValue_EscapeAbout, #KeyboardShortcut_EscapeAbout)
      
      ;--------------------------------------------------------------------------------------------
      ; Stream the RTF 'about' data into the note area from the data section
      ;--------------------------------------------------------------------------------------------

      CatchRTF(#Gadget_About_Information, ?_About)
      
      ;--------------------------------------------------------------------------------------------
      ; Display status to the user
      ;--------------------------------------------------------------------------------------------
      
      SetInfoBarArea("Headings", "Info", Program\LastWindow, "AboutMyInfo")
      
      ;--------------------------------------------------------------------------------------------
      ; Display status to the user
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings",  "Error",  "Could not open the [" + Program\LastWindow + "] window.", "AboutMyInfo")
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; Display status to the user
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Warn",  "The [" +  Program\LastWindow + "] window is still open, close that one first.", "AboutMyInfo")
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 59
; FirstLine = 49
; Folding = -
; EnableXP
; HideErrorLog
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0