;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Manage the owner list table
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure ManageOwners()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected Message.s
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected Category.s
  
  ;------------------------------------------------------------------------------------------------
  ; Check if another window isn't open first
  ;------------------------------------------------------------------------------------------------
  
  If Program\WindowMutex <> #True
    
    ;----------------------------------------------------------------------------------------------
    ; Check to see if the datasheet window could be opened
    ;----------------------------------------------------------------------------------------------
    
    If Window_OwnerList()  <> #NoWindowId
      
      ;--------------------------------------------------------------------------------------------
      ; Add this window's various keyboard shortcuts
      ;--------------------------------------------------------------------------------------------
      
      AddKeyboardShortcut(#Window_OwnerList, #ShortcutValue_SaveOwnerList,    #KeyboardShortcut_SaveOwnerList)
  
      AddKeyboardShortcut(#Window_OwnerList, #ShortcutValue_AddOwnerList,     #KeyboardShortcut_AddOwnerList)
      
      AddKeyboardShortcut(#Window_OwnerList, #ShortcutValue_DeleteOwnerList,  #KeyboardShortcut_DeleteOwnerList)
      
      AddKeyboardShortcut(#Window_OwnerList, #ShortcutValue_EditOwnerList,    #KeyboardShortcut_EditOwnerList)
      
      AddKeyboardShortcut(#Window_OwnerList, #ShortcutValue_SyncOwnerlist,    #KeyboardShortcut_SyncOwnerlist)
      
      AddKeyboardShortcut(#Window_OwnerList, #ShortcutValue_HelpOwnerList,    #KeyboardShortcut_HelpOwnerList)
      
      AddKeyboardShortcut(#Window_OwnerList, #ShortcutValue_ExitOwnerList,    #KeyboardShortcut_ExitOwnerList)
      
      AddKeyboardShortcut(#Window_OwnerList, #ShortcutValue_EscapeownerList,  #KeyboardShortcut_EscapeOwnerList)
      
      ;--------------------------------------------------------------------------------------------
      ; Add the hoverable controls
      ;--------------------------------------------------------------------------------------------
      
      AddHoverGadget(GadgetID(#Gadget_OwnerList_SaveOwnerlist))
      
      AddHoverGadget(GadgetID(#Gadget_OwnerList_AddOwnerlist))
      
      AddHoverGadget(GadgetID(#Gadget_OwnerList_DeleteOwnerlist))
      
      AddHoverGadget(GadgetID(#Gadget_OwnerList_EditOwnerlist))
      
      AddHoverGadget(GadgetID(#Gadget_OwnerList_SyncOwnerlist))
      
      AddHoverGadget(GadgetID(#Gadget_OwnerList_HelpOwnerlist))
      
      AddHoverGadget(GadgetID(#Gadget_OwnerList_ExitOwnerlist))
      
      ;--------------------------------------------------------------------------------------------
      ; These are your balloon tooltips used on the main form. All headings, balloon text and 
      ; icons are re-useable variables taken from the constants file.
      ;--------------------------------------------------------------------------------------------
      
      If Program\BalloonFontId
        
        BalloonToolTip(#Window_OwnerList, #Gadget_OwnerList_SaveOwnerlist,   Program\BalloonFontId, GetBalloonColour(), ShortTooltip\SaveOwnerlist,    #CRLF$ + GetShortCutText(#ShortcutValue_SaveOwnerList)   + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\SaveOwnerList,    30),  GetIconHandle(#Image_OwnerList_SaveOwnerlist))
        
        BalloonToolTip(#Window_OwnerList, #Gadget_OwnerList_AddOwnerlist,    Program\BalloonFontId, GetBalloonColour(), ShortTooltip\AddOwnerList,     #CRLF$ + GetShortCutText(#ShortcutValue_AddOwnerList)    + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\AddOwnerList,     30),  GetIconHandle(#Image_OwnerList_AddOwnerlist))
        
        BalloonToolTip(#Window_OwnerList, #Gadget_OwnerList_DeleteOwnerlist, Program\BalloonFontId, GetBalloonColour(), ShortTooltip\DeleteOwnerList,  #CRLF$ + GetShortCutText(#ShortcutValue_DeleteOwnerList) + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\DeleteOwnerList,  30),  GetIconHandle(#Image_OwnerList_DeleteOwnerlist))
        
        BalloonToolTip(#Window_OwnerList, #Gadget_OwnerList_EditOwnerlist,   Program\BalloonFontId, GetBalloonColour(), ShortTooltip\EditOwnerList,    #CRLF$ + GetShortCutText(#ShortcutValue_EditOwnerList)   + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\EditOwnerList,    30),  GetIconHandle(#Image_OwnerList_EditOwnerlist))
        
        BalloonToolTip(#Window_OwnerList, #Gadget_OwnerList_SyncOwnerlist,   Program\BalloonFontId, GetBalloonColour(), ShortTooltip\SyncOwnerlist,    #CRLF$ + GetShortCutText(#ShortcutValue_SyncOwnerlist)   + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\SyncOwnerlist,    30),  GetIconHandle(#Image_OwnerList_SyncOwnerlist))
        
        BalloonToolTip(#Window_OwnerList, #Gadget_OwnerList_HelpOwnerlist,   Program\BalloonFontId, GetBalloonColour(), ShortTooltip\HelpOwnerList,    #CRLF$ + GetShortCutText(#ShortcutValue_HelpOwnerList)   + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\HelpOwnerList,    30),  GetIconHandle(#Image_OwnerList_HelpOwnerlist))
        
        BalloonToolTip(#Window_OwnerList, #Gadget_OwnerList_ExitOwnerlist,   Program\BalloonFontId, GetBalloonColour(), ShortTooltip\ExitOwnerList,    #CRLF$ + GetShortCutText(#ShortcutValue_ExitOwnerList)   + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\ExitOwnerList,    30),  GetIconHandle(#Image_OwnerList_ExitOwnerlist))
        
      Else
        
        MessageRequesterEBS("Balloon font load error", "Could not load the ballon font so no tooltips will be loaded", #MB_ICONINFORMATION | #PB_MessageRequester_Ok)
        
        ;MessageRequester("Balloon font load error", "Could not load the ballon font so no tooltips will be loaded", #PB_MessageRequester_Ok)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; Disable all input on the main window until this one is closed
      ;--------------------------------------------------------------------------------------------
      
      DisableWindow(#Window_MyInfo, #True)
      
      ;--------------------------------------------------------------------------------------------
      ; Hide the main window until we are finished with the datasheet window
      ;--------------------------------------------------------------------------------------------
      
      ;HideWindow(#Window_MyInfo, #True)
      
      ;--------------------------------------------------------------------------------------------
      ; Add the window title for various procedures and visuals
      ;--------------------------------------------------------------------------------------------

      Program\LastWindow = "List Categories"
      
      ;--------------------------------------------------------------------------------------------
      ; Add a generic message for info bars and title areas
      ;--------------------------------------------------------------------------------------------
      
      Message.s = "Edit category list"
      
      ;--------------------------------------------------------------------------------------------
      ; Set the window title bar with the record number and message
      ;--------------------------------------------------------------------------------------------
      
      SetWindowTitle(#Window_OwnerList, Message.s + NextRecordString.s)
      
      ;--------------------------------------------------------------------------------------------
      ; Populate the list with the categories table
      ;--------------------------------------------------------------------------------------------
      
      DatabaseQuery.s = "SELECT * FROM Owners "
      
      DatabaseQuery.s + "ORDER BY Owner"
      
      If DatabaseQuery(Program\DatabaseHandle, DatabaseQuery.s) <> #DatabaseQueryFail
        
        While NextDatabaseRow(Program\DatabaseHandle) <> #NoItems
          
          passOwner.s        =  KillQuote(GetDatabaseString(Program\DatabaseHandle,  0))
          
          passItemcount.s    =  KillQuote(GetDatabaseString(Program\DatabaseHandle,  1))
          
          passIconname.s     =  KillQuote(GetDatabaseString(Program\DatabaseHandle,  2))
          
          passRecord.s       =  KillQuote(GetDatabaseString(Program\DatabaseHandle,  3))
          
          If FileSize(Program\OwnerIcons  + passIconname.s) <> #NoPictureFound  And FileSize(Program\OwnerIcons  + passIconname.s) <> #FileIsDirectory
            
            UserIconHandle.i = LoadImage(#PB_Any, Program\OwnerIcons  + passIconname.s)
            
            If UserIconHandle.i <>  #NoPictureLoaded
              
              AddGadgetItem(#Gadget_OwnerList_Owners, #AtTheEndOfTheList, passOwner.s + #LF$  + passItemcount.s  + #LF$  + passIconname.s + #LF$  + passRecord.s, ImageID(UserIconHandle.i))
              
            Else
              
              AddGadgetItem(#Gadget_OwnerList_Owners, #AtTheEndOfTheList, passOwner.s + #LF$  + #Empty$  + #LF$  + passIconname.s + #LF$  + passRecord.s, ImageID(#Image_ListOwner))
              
              SetInfoBarArea("Headings", "Error", "Could load the icon file as it is damaged.", #PB_Compiler_Procedure)
              
            EndIf
            
          Else
            
            AddGadgetItem(#Gadget_OwnerList_Owners, #AtTheEndOfTheList, passOwner.s + #LF$  + #Empty$  + #LF$  + passIconname.s + #LF$  + passRecord.s, ImageID(#Image_ListOwner))
            
            SetInfoBarArea("Headings", "Error", "Could load the icon file as it was not found.", #PB_Compiler_Procedure)
            
          EndIf
          
        Wend
        
        FinishDatabaseQuery(Program\DatabaseHandle)        
        
      Else
        
        SetInfoBarArea("Headings",  "Error", "Database query failed or returned no data:  " + DatabaseError(), #PB_Compiler_Procedure)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; Make sure this window is active for input
      ;--------------------------------------------------------------------------------------------
      
      SetActiveWindow(#Window_OwnerList)
      
      ;--------------------------------------------------------------------------------------------
      ; Make sure the itemname field is ready for input
      ;--------------------------------------------------------------------------------------------

      SetActiveGadget(#Gadget_OwnerList_Owners)
      
      ;--------------------------------------------------------------------------------------------
      ; Add the message to the main window fake status area
      ;--------------------------------------------------------------------------------------------
      
      SetInfoBarArea("Headings",  "Info",  Message.s + NextRecordString.s, #PB_Compiler_Procedure)
      
      ;--------------------------------------------------------------------------------------------
      ; Go here if we could not open this data sheet window
      ;--------------------------------------------------------------------------------------------

    Else
      
      SetInfoBarArea("Headings",  "Warn",  "Could not open the "  + Program\LastWindow  + " window", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; Go here if there is another program window open. Programmer error
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Error",  Program\LastWindow + " is still open bozo, close that one first", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Nothing more to do folks
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 96
; FirstLine = 73
; Folding = -
; EnableAsm
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableExeConstant
; EnableUnicode