;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Check that there is a new password
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure CheckNewPassWord()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  FocusID.i = GetActiveGadget()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Select FocusId.i
      
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
      
    Case #Gadget_NewPassword_NewPassWord
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If Program\NewPassWord <> #Empty$
        
        ;------------------------------------------------------------------------------------------
        ; The program password is not empty
        ;------------------------------------------------------------------------------------------
        
        If Len(Program\NewPassWord) > 7 And Len(Program\NewPassWord) < 26
          
          ;----------------------------------------------------------------------------------------
          ; The password is long enough
          ;----------------------------------------------------------------------------------------
          
          DisableGadget(#Gadget_NewPassword_ConfirmPassWord, #False)
          
          SetActiveGadget(#Gadget_NewPassword_ConfirmPassWord)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          ;----------------------------------------------------------------------------------------
          ; The specified password is not long enough
          ;----------------------------------------------------------------------------------------
          
          DisableGadget(#Gadget_NewPassword_ConfirmPassWord, #True)
          
          MessageString.s = "Password too short." + #CRLF$ + #CRLF$  + "It must be between 8 and 25 characters in length."
          
          MessageRequesterEBS("Security Error", MessageString.s, #MB_ICONINFORMATION | #PB_MessageRequester_Ok)
          
          ;MessageRequester("Security Error", MessageString.s,  #MB_ICONWARNING)
          
          SetGadgetText(#Gadget_NewPassword_NewPassWord, #Empty$)
          
          SetActiveGadget(#Gadget_NewPassword_NewPassWord)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      ElseIf Program\NewPassWord = #Empty$
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        DisableGadget(#Gadget_NewPassword_ConfirmPassWord, #True)
        
        MessageString.s = "Password empty." + #CRLF$ + #CRLF$ + "Try again or press ESCape to exit."
        
        MessageRequesterEBS("Security Error", MessageString.s, #MB_ICONINFORMATION | #PB_MessageRequester_Ok)
        
        ;MessageRequester("Security Error",  MessageString.s,  #MB_ICONWARNING)
        
        SetActiveGadget(#Gadget_NewPassword_NewPassWord)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Case #Gadget_NewPassword_ConfirmPassWord
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If ConfirmPassWord.s = #Empty$
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        MessageString.s = "Confirmation password empty." + #CRLF$ + #CRLF$ + "Try again or press ESCape to exit."
        
        MessageRequesterEBS("Security Error", MessageString.s, #MB_ICONINFORMATION | #PB_MessageRequester_Ok)
        
        ;MessageRequester("Security Error",  MessageString.s, #MB_ICONWARNING)
        
        SetGadgetText(#Gadget_NewPassword_ConfirmPassWord, #Empty$)
        
        SetActiveGadget(#Gadget_NewPassword_ConfirmPassWord)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      ElseIf ConfirmPassWord.s <> Program\NewPassWord
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        MessageString.s = "The passwords do not match." + #CRLF$ + #CRLF$ + "Try again or press ESCape to exit."
        
        MessageRequesterEBS("Security Error", MessageString.s, #MB_ICONINFORMATION | #PB_MessageRequester_Ok)
        
        ;MessageRequester("Security Error", MessageString.s,  #MB_ICONWARNING)
        
        SetGadgetText(#Gadget_NewPassword_ConfirmPassWord, #Empty$)
        
        SetActiveGadget(#Gadget_NewPassword_ConfirmPassWord)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      ElseIf ConfirmPassWord.s  = Program\NewPassWord
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        Program\MD5FingerPrint = Fingerprint(@ConfirmPassWord,  Len(ConfirmPassWord.s), #PB_Cipher_MD5)
        
        QueryString.s                     + 

        "UPDATE Preferences "             + 

        "SET MD5FingerPrint = '"          + 

        RepQuote(Program\MD5FingerPrint)  + 

        "' "                              + 

        "WHERE Recordid = '1'"
        
        If DatabaseUpdate(Program\DatabaseHandle, QueryString.s) = 0
          
          
          MessageString.s = "Could not add new password to database." + #CRLF$ + #CRLF$ + DatabaseError()
          
          MessageRequesterEBS("Security Error", MessageString.s, #MB_ICONINFORMATION | #PB_MessageRequester_Ok)
          
          ;MessageRequester("Security Error", MessageString.s,  #MB_ICONWARNING)
          
          SetInfoBarArea("Headings",  "Error", MessageString.s)
          
        EndIf
        
        Program\NewPassWord = #Empty$
        
        QuitPasswordValue.i = #True
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 168
; FirstLine = 160
; Folding = -
; EnableXP
; HideErrorLog
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableExeConstant