;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Check the startup unlocking password
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure CheckStartUpPassWord()
  
  ;----------------------------------------------------------------------------------------------
  ; 
  ;----------------------------------------------------------------------------------------------
  
  ; Shared QuitPasswordValue.i
  
  ;----------------------------------------------------------------------------------------------
  ; Get the stored password from the database
  ;----------------------------------------------------------------------------------------------
  
  QueryString.s             + 

  "SELECT MD5FingerPrint "  + 
  
  "FROM Preferences "       + 
  
  "WHERE Recordid = '1'"
  
  ;----------------------------------------------------------------------------------------------
  ; 
  ;----------------------------------------------------------------------------------------------
  
  If DatabaseQuery(Program\DatabaseHandle, QueryString.s) <>  #DatabaseQueryFail
    
    While NextDatabaseRow(Program\DatabaseHandle)
      
      StoredPassWord.s = KillQuote(GetDatabaseString(Program\DatabaseHandle, 0))
      
    Wend
    
    FinishDatabaseQuery(Program\DatabaseHandle)
    
  EndIf
  
  ;----------------------------------------------------------------------------------------------
  ; Get the comparison password from the user
  ;----------------------------------------------------------------------------------------------
  
  StartupPassWord.s    = GetGadgetText(#Gadget_StartUpPassword_UnlockPassWord)
  
  ;----------------------------------------------------------------------------------------------
  ; Check to see if the user entered an empty password
  ;----------------------------------------------------------------------------------------------
  
  If StartupPassWord.s = #Empty$
    
    ;--------------------------------------------------------------------------------------------
    ; Give the user a message about empty password being disallowed
    ;--------------------------------------------------------------------------------------------
    
    MessageString.s = "Password field must not be empty."  + #CRLF$ + #CRLF$
    
    MessageString.s + "Try again, or press ESC to exit."
    
    MessageRequesterEBS("Security Error", MessageString.s, #MB_ICONINFORMATION | #PB_MessageRequester_Ok)
    
    ;MessageRequester("Security Error",  MessageString.s,  #MB_ICONWARNING)
    
    SetGadgetText(#Gadget_StartUpPassword_UnlockPassWord, #Empty$)
    
    SetActiveGadget(#Gadget_StartUpPassword_UnlockPassWord)
    
    ;--------------------------------------------------------------------------------------------
    ; Check the password if it isn't empty
    ;--------------------------------------------------------------------------------------------
    
  ElseIf StartupPassWord.s <> #Empty$
    
    ;--------------------------------------------------------------------------------------------
    ; Fingeprint the user supplied password for comparison
    ;--------------------------------------------------------------------------------------------
    
    StartupPassWord.s    = Fingerprint(@StartupPassWord,  Len(StartupPassWord.s), #PB_Cipher_MD5)

    ;--------------------------------------------------------------------------------------------
    ; 
    ;--------------------------------------------------------------------------------------------
    
    If StartupPassWord.s <> StoredPassWord.s
      
      MessageString.s = "Password does not match" + #CRLF$ + #CRLF$ + "Try again, or press ESC to exit."
      
      MessageRequesterEBS("Security Error", MessageString.s, #MB_ICONINFORMATION | #PB_MessageRequester_Ok)
      
      ;MessageRequester("Password Error",  MessageString.s,  #MB_ICONWARNING)
      
      SetGadgetText(#Gadget_StartUpPassword_UnlockPassWord, #Empty$)
      
      SetActiveGadget(#Gadget_StartUpPassword_UnlockPassWord)
      
    ElseIf  StartupPassWord.s = StoredPassWord.s
      
      QuitPasswordValue.i = 1
      
    EndIf
    
    ;--------------------------------------------------------------------------------------------
    ; 
    ;--------------------------------------------------------------------------------------------
    
  EndIf
  
  ;----------------------------------------------------------------------------------------------
  ; 
  ;----------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 24
; FirstLine = 21
; Folding = -
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableExeConstant