﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Breeze4me's solution to disable an imagegadget
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

UseJPEGImageDecoder()

Declare   FilterCallback(x, y, SourceColor, TargetColor)
Declare   DisableImageGadget(Gadget, SrcImage, State)

Procedure FilterCallback(x, y, SourceColor, TargetColor)
  ;Protected Green = Green(SourceColor)
  ;ProcedureReturn RGBA(Green, Green, Green, Alpha(SourceColor))
   Protected col = Red(SourceColor) * 0.2999 + Green(SourceColor) * 0.587 + Blue(SourceColor) * 0.114
  ProcedureReturn RGBA(col, col, col, Alpha(SourceColor))
EndProcedure

Procedure DisableImageGadget(Gadget, SrcImage, State)
  Protected DisabledImage = GetGadgetData(Gadget)
 
  If DisabledImage <> -1 And IsImage(DisabledImage)
    SetGadgetData(Gadget, -1)
    FreeImage(DisabledImage)
  EndIf
 
  If IsImage(SrcImage)
    If State
      DisabledImage = CreateImage(#PB_Any, ImageWidth(SrcImage), ImageHeight(SrcImage), ImageDepth(SrcImage))
      If DisabledImage
        If StartDrawing(ImageOutput(DisabledImage))
          DrawingMode(#PB_2DDrawing_CustomFilter)
          CustomFilterCallback(@FilterCallback())
          DrawImage(ImageID(SrcImage), 0, 0)
          DrawingMode(#PB_2DDrawing_Transparent )
          DrawText(15,15,">>>", $FFFFFF)
          StopDrawing()
         
          SetGadgetState(Gadget, ImageID(DisabledImage))
          SetGadgetData(Gadget, DisabledImage)
        EndIf
      EndIf
    Else
      SetGadgetState(Gadget, ImageID(SrcImage))
    EndIf
  EndIf
  DisableGadget(Gadget, State)
EndProcedure

; If OpenWindow(0, 0, 0, 700, 500, "ImageGadget", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
;   If LoadImage(0, #PB_Compiler_Home + "Examples\3D\Data\Textures\ValetCoeur.jpg")
;     ImageGadget(0,  10, 10, 100, 83, ImageID(0))
;     SetGadgetData(0, -1) ; essential line !
;    
;     ImageGadget(1, 350, 10, 100, 83, ImageID(0))
;     SetGadgetData(1, -1) ; essential line !
;    
;     ;DisableImageGadget(0, 0, 1)
;     ;DisableImageGadget(0, 0, 0)
;     DisableImageGadget(1, 0, 1)
;     ;DisableImageGadget(1, 0, 0)
;    
;   EndIf
;   Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
; EndIf




; IDE Options = PureBasic 5.70 LTS (Windows - x86)
; CursorPosition = 35
; FirstLine = 19
; Folding = -
; EnableAsm
; EnableThread
; EnableXP
; EnableOnError
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableExeConstant