;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Search any records based on fuzzy Search logic
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure AdvancedSearchNow()
 
  ;------------------------------------------------------------------------------------------------
  ; Clear the existing display if it contains items
  ;------------------------------------------------------------------------------------------------
  
  If CountGadgetItems(#Gadget_MyInfo_Titles) <> #NoItems
    
    ClearGadgetItems(#Gadget_MyInfo_Titles)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Get the type of SQL Search to perform
  ;------------------------------------------------------------------------------------------------
  
  SearchType.s    = GetGadgetText(#Gadget_Search_SearchType)
  
  ;------------------------------------------------------------------------------------------------
  ; Get the field to perform the Search in
  ;------------------------------------------------------------------------------------------------
  
  SearchField.i   = GetGadgetState(#Gadget_Search_SearchField)
  
  ;------------------------------------------------------------------------------------------------
  ; Get the Search text for recipes to return
  ;------------------------------------------------------------------------------------------------
  
  SearchText.s    = RepQuote(GetGadgetText(#Gadget_Search_SearchText))
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Program\LastSearch  = SearchText.s
  
  QueryString.s       = "UPDATE Preferences "
  
  QueryString.s       + "SET LastSearch = '" + RepQuote(Program\LastSearch)  + "') "
  
  QueryString.s       + "WHERE Record = '1'"
  
  DatabaseUpdate(Program\DatabaseHandle, QueryString.s)
  
  ;------------------------------------------------------------------------------------------------
  ; Get the field to perform the sort on
  ;------------------------------------------------------------------------------------------------

  SortField.i   = GetGadgetState(#Gadget_Search_SortField)
  
  ;------------------------------------------------------------------------------------------------
  ; Get the SQL sort direction
  ;------------------------------------------------------------------------------------------------

  If GetGadgetState(#Gadget_Search_oSortAcending)
    
    SortDirection.s = " ASC "
    
  ElseIf GetGadgetState(#Gadget_Search_oSortDescending)
    
    SortDirection.s = " DESC "
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Get the limit for the number of data items to return
  ;------------------------------------------------------------------------------------------------
  
  If GetGadgetState(#Gadget_Search_cbQueryReturnLimit) = 1
    
    SortLimit.s = " LIMIT " + GetGadgetText(#Gadget_Search_sQueryReturnLimit)
    
  Else
    
    SortLimit.s = " LIMIT 500"
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Alias the Search field numbers to database field names
  ;------------------------------------------------------------------------------------------------
  
  Select SearchField.i

    Case   0  : SearchFieldText.s = "All fields"

    Case   1  : SearchFieldText.s = "Title"

    Case   2  : SearchFieldText.s = "Information"

    Case   3  : SearchFieldText.s = "Category"

    Case   4  : SearchFieldText.s = "Favourite"

    Case   5  : SearchFieldText.s = "Locked"

    Case   6  : SearchFieldText.s = "Deleted"

    Case   7  : SearchFieldText.s = "Updated"
      
    Case   8  : SearchFieldText.s = "Owner"

    Case   9  : SearchFieldText.s = "Attachments"

    Case  10  : SearchFieldText.s = "Record"

  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Select SortField.i

   ;Case   0  : SortFieldText.s = "All fields"
      
    Case   0  : SortFieldText.s = "Title"
      
    Case   1  : SortFieldText.s = "Title"

    Case   2  : SortFieldText.s = "Information"

    Case   3  : SortFieldText.s = "Category"

    Case   4  : SortFieldText.s = "Favourite"

    Case   5  : SortFieldText.s = "Locked"

    Case   6  : SortFieldText.s = "Deleted"

    Case   7  : SortFieldText.s = "Updated"

    Case   8  : SortFieldText.s = "Owner"

    Case   9  : SortFieldText.s = "Attachments"

    Case  10  : SortFieldText.s = "Record"

  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; Set the initial total item counter
  ;------------------------------------------------------------------------------------------------
  
  ItemCounter.i   = #NoItems
  
  ;------------------------------------------------------------------------------------------------
  ; Alias the Search type text to SQLite operators
  ;------------------------------------------------------------------------------------------------
  
  SearchCommand.s = SetSearchQuery(SearchType.s, SearchText.s)
  
  ;------------------------------------------------------------------------------------------------
  ; Search all fields or just a specific field
  ;------------------------------------------------------------------------------------------------
  
  Select SearchFieldText.s
      
    Case "All fields"
      
      QueryString.s = "SELECT * FROM MyInfo WHERE ("
      
      QueryString.s + "Title"            + SearchCommand.s
      
      QueryString.s + " OR Information"  + SearchCommand.s
      
      QueryString.s + " OR Category"     + SearchCommand.s
      
      ;       QueryString.s + " OR Favourite"    + SearchCommand.s
      ;       
      ;       QueryString.s + " OR Locked"       + SearchCommand.s
      ;       
      ;       QueryString.s + " OR Deleted"      + SearchCommand.s
      ;       
      ;       QueryString.s + " OR Updated"      + SearchCommand.s
      ;       
      ;       QueryString.s + " OR Owner"        + SearchCommand.s
      ;       
      ;       QueryString.s + " OR Attachments"  + SearchCommand.s
      ;       
      ;       QueryString.s + " OR Record"       + SearchCommand.s
      
      QueryString.s + ")"
      
      QueryString.s + " ORDER BY " + SortFieldText.s + SortDirection.s + SortLimit.s
      
      ;--------------------------------------------------------------------------------------------
      ; Category & Owner can have multiple items searched separated by commas
      ;--------------------------------------------------------------------------------------------
      
    Case "Information", "Category", "Owner"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If GetGadgetState(#Gadget_Search_oCheckOr) = #True
        
        SearchMode.s = " OR "
        
      ElseIf  GetGadgetState (#Gadget_Search_oCheckAnd) = #True
        
        SearchMode.s = " AND "
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; Search out how many items that the user wishes to search for
      ;--------------------------------------------------------------------------------------------
      
      NumberOfItems.i = CountString(SearchText.s, ",")
      
      ;--------------------------------------------------------------------------------------------
      ; Separate each item into a separate SQL component with the right keyword
      ;--------------------------------------------------------------------------------------------
      
      If NumberOfItems.i
        
        For GetItems.i = 1 To NumberOfItems.i + 1
          
          GetItemString.s + FieldText.s
          
          GetItemString.s + SetSearchQuery(SearchType.s, StringField(SearchText.s, GetItems.i, ","))
          
          If GetItems.i <> NumberOfItems.i + 1
            
            GetItemString.s + SearchMode.s
            
          Else
            
            GetItemString.s + #Empty$
            
          EndIf
          
        Next GetItems.i
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        QueryString.s = "SELECT * FROM MyInfo WHERE ("
        
        QueryString.s + GetItemString.s
        
        QueryString.s + ")"
        
        QueryString.s + " ORDER BY " + SortFieldText.s + SortDirection.s + SortLimit.s
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        QueryString.s = "SELECT * FROM MyInfo WHERE ("
        
        QueryString.s + SearchFieldText.s
        
        QueryString.s + SetSearchQuery(SearchType.s, SearchText.s)
        
        QueryString.s + ")"
        
        QueryString.s + " ORDER BY " + SortFieldText.s + SortDirection.s + SortLimit.s
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------

    Default
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      QueryString.s = "SELECT * FROM MyInfo WHERE "
      
      QueryString.s + SearchFieldText.s
      
      QueryString.s + SearchCommand.s
      
      QueryString.s + " ORDER BY " + SortFieldText.s + SortDirection.s + SortLimit.s

      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
  EndSelect
  
  ; QueryString.s
  
  ;------------------------------------------------------------------------------------------------
  ; Run the query with the chosen details
  ;------------------------------------------------------------------------------------------------
  
  If DatabaseQuery(Program\DatabaseHandle,  QueryString.s)  <> #DatabaseQueryFail
    
    While NextDatabaseRow(Program\DatabaseHandle)
      
      MyInfo\Title        = KillQuote(GetDatabaseString(Program\DatabaseHandle,  0))                 ;
      
      MyInfo\Information  = KillQuote(GetDatabaseString(Program\DatabaseHandle,  1))                 ;
      
      MyInfo\Category     = KillQuote(GetDatabaseString(Program\DatabaseHandle,  2))                 ;
      
      MyInfo\Archived     =           GetDatabaseString(Program\DatabaseHandle,  3)                  ;
      
      MyInfo\Favourite    =           GetDatabaseString(Program\DatabaseHandle,  4)                  ;
      
      MyInfo\Locked       =           GetDatabaseString(Program\DatabaseHandle,  5)                  ;
      
      MyInfo\Deleted      =           GetDatabaseString(Program\DatabaseHandle,  6)                  ;
      
      MyInfo\Updated      =   IsoDate(GetDatabaseString(Program\DatabaseHandle,  7), "NormalDate")   ;
      
      MyInfo\Owner        = KillQuote(GetDatabaseString(Program\DatabaseHandle,  8))                 ;
      
      MyInfo\Attachments  =           GetDatabaseString(Program\DatabaseHandle,  9)                  ;
      
      MyInfo\Recordid     =           GetDatabaseString(Program\DatabaseHandle, 10)                  ;
      
      ;--------------------------------------------------------------------------------------------
      ; Set the correct icon in the ListIcongadget for normal or favourite recipe
      ;--------------------------------------------------------------------------------------------
      
      DisplayTitleString(ItemCounter.i, "AddMode")
      
      ItemCounter.i + 1
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Wend
    
    ;----------------------------------------------------------------------------------------------
    ; Clear the query buffer
    ;----------------------------------------------------------------------------------------------
    
    FinishDatabaseQuery(Program\DatabaseHandle)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SetInfoBarArea("Records", #Empty$, Str(ItemCounter.i), #PB_Compiler_Procedure)
    
    ;----------------------------------------------------------------------------------------------
    ; Load the items for the first location in the list
    ;----------------------------------------------------------------------------------------------
    
    If ItemCounter.i <> #NoItems
      
      SetActiveGadget(#Gadget_MyInfo_Titles)
      
      SetGadgetItemState(#Gadget_MyInfo_Titles, 0, #PB_ListIcon_Selected)
      
      PostEvent(#PB_Event_Gadget, #Window_MyInfo, #Gadget_MyInfo_Titles, #PB_EventType_Change)
      
    Else
      
      ;--------------------------------------------------------------------------------------------
      ; Clear all data on main form before putting in the new details
      ;--------------------------------------------------------------------------------------------
      
      SetGadgetText(#Gadget_MyInfo_Information,    #Empty$)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    EndIf
    
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SetInfoBarArea("Records", #Empty$, Str(CountGadgetItems(#Gadget_MyInfo_Titles)), #PB_Compiler_Procedure)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Error", "The database query failed. " + DatabaseError(), #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If GetGadgetState(#Gadget_Search_cbCheckEnter)
    
    CloseMyWindow(#Window_Search)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 40
; FirstLine = 369
; Folding = -
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableExeConstant